/*
 * File: app/view/discoveryView.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Discovery.view.discoveryView', {
	extend: 'Ext.container.Container',
	alias: 'widget.discoveryview',

	requires: [
		'Ext.panel.Tool',
		'Ext.button.Button',
		'Ext.form.Panel',
		'Ext.grid.Panel',
		'Ext.grid.column.Column',
		'Ext.grid.View',
		'Ext.selection.CheckboxModel',
		'Ext.toolbar.Paging',
		'Ext.XTemplate',
		'Ext.form.FieldSet',
		'Ext.form.field.ComboBox',
		'Ext.form.field.Checkbox'
	],

	id: 'discoveryView',
	minWidth: 940,

	layout: {
		type: 'vbox',
		align: 'stretch'
	},

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'panel',
					cls: 'top_bar',
					height: 36,
					id: 'header',
					padding: '0 0 5 0',
					header: false,
					title: 'Configuração inicial do OpMon 6.0',
					layout: {
						type: 'hbox',
						align: 'stretch',
						pack: 'center'
					},
					tools: [
						{
							xtype: 'tool',
							id: 'helpButton4',
							tooltip: 'Ajuda',
							type: 'help'
						}
					],
					items: [
						{
							xtype: 'container',
							cls: 'top_bar',
							html: '<h4 class="header-title">Configuração inicial do OpMon 6</h4>',
							id: 'headerTitle4',
							margin: '-12 0',
							padding: '0 0 0 10',
							listeners: {
								beforerender: {
									fn: me.onHeaderTitle4BeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'container',
							flex: 4,
							height: 36,
							id: 'sectionContainer4',
							items: [
								{
									xtype: 'toolbar',
									cls: 'top_bar',
									height: 36,
									id: 'sectionNav4',
									layout: {
										type: 'hbox',
										pack: 'center',
										padding: '5 0 0'
									},
									items: [
										{
											xtype: 'button',
											cls: 'bread-button bread-button-active',
											disabled: true,
											id: 'breadBtnStep13',
											overCls: 'none',
											allowDepress: false,
											glyph: 49,
											text: 'Definir senha do administrador',
											listeners: {
												beforerender: {
													fn: me.onBreadBtnStep13BeforeRender,
													scope: me
												}
											}
										},
										{
											xtype: 'button',
											cls: 'bread-button',
											id: 'breadBtnStep14',
											overCls: 'none',
											allowDepress: false,
											enableToggle: true,
											glyph: 50,
											text: 'Descobrir elementos da rede',
											listeners: {
												beforerender: {
													fn: me.onBreadBtnStep14BeforeRender,
													scope: me
												}
											}
										},
										{
											xtype: 'button',
											cls: 'bread-button',
											disabled: true,
											id: 'breadBtnStep15',
											overCls: 'none',
											allowDepress: false,
											glyph: 51,
											text: 'Gerar topologia',
											listeners: {
												beforerender: {
													fn: me.onBreadBtnStep15BeforeRender,
													scope: me
												}
											}
										}
									]
								}
							]
						},
						{
							xtype: 'panel',
							baseCls: 'top_bar',
							id: 'helpPanel3',
							minWidth: 60,
							headerOverCls: 'helpPanel3',
							title: '',
							tools: [
								{
									xtype: 'tool',
									handler: function(event, toolEl, owner, tool) {
										window.open(l["Knowledge Base Link"],'_blank');
									},
									type: 'help'
								}
							]
						}
					]
				},
				{
					xtype: 'panel',
					flex: 1,
					id: 'content',
					layout: 'border',
					header: false,
					title: 'content',
					items: [
						{
							xtype: 'panel',
							flex: 1,
							region: 'center',
							cls: 'x-container',
							id: 'rightContent',
							collapsible: false,
							frameHeader: false,
							header: false,
							title: 'Elementos Descobertos',
							titleAlign: 'left',
							layout: {
								type: 'vbox',
								align: 'stretch'
							},
							items: [
								{
									xtype: 'container',
									flex: 1,
									cls: 'x-panel-header-default',
									height: 36,
									id: 'fake_header',
									maxHeight: 36,
									layout: {
										type: 'hbox',
										align: 'stretch'
									},
									items: [
										{
											xtype: 'panel',
											id: 'fake_header_panel',
											maxWidth: 200,
											width: 200,
											title: 'Elementos Descobertos',
											listeners: {
												beforerender: {
													fn: me.onFake_header_panelBeforeRender,
													scope: me
												}
											}
										},
										{
											xtype: 'form',
											flex: 1,
											id: 'filterElements',
											padding: 5,
											bodyStyle: '{background:transparent;}',
											header: false,
											title: 'My Form',
											layout: {
												type: 'hbox',
												align: 'stretch',
												pack: 'end'
											},
											items: [
												{
													xtype: 'container',
													flex: 1
												},
												{
													xtype: 'triggerfield',
													flex: 5,
													border: true,
													maxWidth: 400,
													fieldLabel: 'Filtrar',
													hideLabel: true,
													labelSeparator: ' ',
													labelWidth: 40,
													emptyText: 'Filtrar elementos descobertos',
													enableKeyEvents: true,
													triggerCls: 'search-trigger',
													listeners: {
														keyup: {
															fn: me.onTextfieldKeyup,
															scope: me
														},
														beforerender: {
															fn: me.onTriggerfieldBeforeRender,
															scope: me
														}
													}
												}
											]
										},
										{
											xtype: 'container',
											id: 'process_spacer',
											width: 294,
											items: [
												{
													xtype: 'container',
													hideMode: 'visibility',
													id: 'processSection',
													margin: '0 18 18',
													minHeight: 50,
													layout: {
														type: 'vbox',
														align: 'stretch',
														padding: '0 10'
													},
													listeners: {
														afterrender: {
															fn: me.onProcessSectionAfterRender,
															scope: me
														}
													}
												}
											]
										}
									]
								},
								{
									xtype: 'container',
									flex: 1,
									id: 'elementsDiscovered',
									rtl: false,
									autoScroll: true,
									layout: {
										type: 'hbox',
										align: 'stretch'
									},
									items: [
										{
											xtype: 'gridpanel',
											flex: 2,
											id: 'discoveredElementsGrid',
											autoScroll: true,
											header: false,
											title: 'Elementos descobertos',
											titleCollapse: false,
											columnLines: true,
											forceFit: true,
											store: 'HostDiscoveryDB',
											columns: [
												{
													xtype: 'gridcolumn',
													enableColumnHide: false,
													dataIndex: 'host_name',
													hideable: false,
													text: 'Host Name',
													flex: 1,
													listeners: {
														beforerender: {
															fn: me.onGridcolumnBeforeRender,
															scope: me
														}
													}
												},
												{
													xtype: 'gridcolumn',
													defaultWidth: 190,
													enableColumnHide: false,
													dataIndex: 'host_ip',
													groupable: false,
													hideable: false,
													text: 'IP Address',
													flex: 1,
													listeners: {
														beforerender: {
															fn: me.onGridcolumnBeforeRender1,
															scope: me
														}
													}
												},
												{
													xtype: 'gridcolumn',
													cls: '',
													defaultWidth: 200,
													enableColumnHide: false,
													sortable: true,
													dataIndex: 'alias',
													hideable: false,
													tdCls: 'even-column',
													text: 'Description',
													flex: 2,
													listeners: {
														beforerender: {
															fn: me.onGridcolumnBeforeRender2,
															scope: me
														}
													}
												}
											],
											viewConfig: {
												disableSelection: false,
												enableTextSelection: false,
												listeners: {
													cellclick: {
														fn: me.onViewCellClick,
														scope: me
													},
													itemmouseenter: {
														fn: me.onViewItemMouseEnter,
														scope: me
													}
												}
											},
											selModel: Ext.create('Ext.selection.CheckboxModel', {
												allowDeselect: true,
												toggleOnClick: false,
												ignoreRightMouseSelection: true,
												checkOnly: true,
												showHeaderCheckbox: true,
												listeners: {
													selectionchange: {
														fn: me.onCheckboxModelSelectionChange,
														scope: me
													}
												}
											}),
											dockedItems: [
												{
													xtype: 'pagingtoolbar',
													dock: 'bottom',
													width: 360,
													beforePageText: ' ',
													displayMsg: ' ',
													emptyMsg: ' ',
													firstText: ' ',
													lastText: ' ',
													nextText: ' ',
													prevText: ' ',
													refreshText: ' ',
													store: 'HostDiscoveryDB',
													listeners: {
														beforerender: {
															fn: me.onPagingtoolbarBeforeRender,
															scope: me
														}
													},
													items: [
														{
															xtype: 'container',
															flex: 1,
															height: 36,
															html: '<p id=\'rightP\'><span id=\'nSelectedElements\'>0</span> elemento(s) selecionado(s)</p>',
															id: 'elementCounter',
															margin: '-17 0 0',
															padding: 10,
															listeners: {
																beforerender: {
																	fn: me.onElementCounterBeforeRender,
																	scope: me
																}
															}
														}
													]
												}
											]
										},
										{
											xtype: 'panel',
											flex: 1,
											cls: 'x-column-header',
											hidden: true,
											id: 'detailsPanel',
											maxWidth: 300,
											minWidth: 300,
											closable: true,
											closeAction: 'hide',
											collapsed: false,
											title: 'Details',
											layout: {
												type: 'accordion',
												hideCollapseTool: false
											},
											items: [
												{
													xtype: 'panel',
													id: 'detailsPanelsDisks',
													autoScroll: true,
													title: 'Disks',
													layout: {
														type: 'vbox',
														align: 'stretch'
													},
													items: [
														{
															xtype: 'gridpanel',
															id: 'disksDetails',
															header: false,
															title: 'My Grid Panel',
															forceFit: true,
															hideHeaders: true,
															columns: [
																{
																	xtype: 'gridcolumn',
																	renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
																		return record.data.field1;
																	},
																	dataIndex: 'string',
																	text: 'Description'
																}
															],
															viewConfig: {
																disableSelection: true,
																emptyText: 'no Data avaliable',
																listeners: {
																	beforerender: {
																		fn: me.onViewBeforeRender,
																		scope: me
																	}
																}
															}
														}
													],
													listeners: {
														beforerender: {
															fn: me.onDetailsPanelsDisksBeforeRender,
															scope: me
														}
													}
												},
												{
													xtype: 'panel',
													id: 'detailsPanelsInterfaces',
													autoScroll: true,
													title: 'Interfaces',
													layout: {
														type: 'vbox',
														align: 'stretch'
													},
													items: [
														{
															xtype: 'gridpanel',
															id: 'interfacesDetails',
															header: false,
															title: 'My Grid Panel',
															forceFit: true,
															hideHeaders: true,
															columns: [
																{
																	xtype: 'gridcolumn',
																	renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
																		return record.data.field1;
																	},
																	dataIndex: 'string',
																	text: 'Description'
																}
															],
															viewConfig: {
																disableSelection: true,
																emptyText: 'no Data avaliable',
																listeners: {
																	beforerender: {
																		fn: me.onViewBeforeRender1,
																		scope: me
																	}
																}
															}
														}
													],
													listeners: {
														beforerender: {
															fn: me.onDetailsPanelsInterfacesBeforeRender,
															scope: me
														}
													}
												},
												{
													xtype: 'panel',
													id: 'detailsPanelsProcesses',
													autoScroll: true,
													title: 'Processes',
													layout: {
														type: 'vbox',
														align: 'stretch'
													},
													items: [
														{
															xtype: 'gridpanel',
															id: 'processesDetails',
															header: false,
															title: 'My Grid Panel',
															forceFit: true,
															hideHeaders: true,
															columns: [
																{
																	xtype: 'gridcolumn',
																	renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
																		return record.data.field1;
																	},
																	dataIndex: 'string',
																	text: 'Description'
																}
															],
															viewConfig: {
																disableSelection: true,
																emptyText: 'no Data avaliable',
																listeners: {
																	beforerender: {
																		fn: me.onViewBeforeRender2,
																		scope: me
																	}
																}
															}
														}
													],
													listeners: {
														beforerender: {
															fn: me.onDetailsPanelsProcessesBeforeRender,
															scope: me
														}
													}
												},
												{
													xtype: 'panel',
													id: 'detailsPanelsServices',
													autoScroll: true,
													title: 'Services',
													layout: {
														type: 'vbox',
														align: 'stretch'
													},
													items: [
														{
															xtype: 'gridpanel',
															id: 'servicesDetails',
															header: false,
															title: 'My Grid Panel',
															forceFit: true,
															hideHeaders: true,
															columns: [
																{
																	xtype: 'gridcolumn',
																	renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
																		return record.data.field1;
																	},
																	dataIndex: 'string',
																	text: 'Description'
																}
															],
															viewConfig: {
																disableSelection: true,
																emptyText: 'no Data avaliable',
																listeners: {
																	beforerender: {
																		fn: me.onViewBeforeRender3,
																		scope: me
																	}
																}
															}
														}
													],
													listeners: {
														beforerender: {
															fn: me.onDetailsPanelsServicesBeforeRender,
															scope: me
														}
													}
												},
												{
													xtype: 'panel',
													id: 'detailsPanelsPorts',
													autoScroll: true,
													title: 'Ports',
													layout: {
														type: 'vbox',
														align: 'stretch'
													},
													items: [
														{
															xtype: 'gridpanel',
															id: 'portDetails',
															header: false,
															title: 'My Grid Panel',
															forceFit: true,
															hideHeaders: true,
															columns: [
																{
																	xtype: 'gridcolumn',
																	renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
																		return record.data.field1;
																	},
																	dataIndex: 'string',
																	text: 'Description'
																}
															],
															viewConfig: {
																disableSelection: true,
																emptyText: 'no Data avaliable',
																listeners: {
																	beforerender: {
																		fn: me.onViewBeforeRender4,
																		scope: me
																	}
																}
															}
														}
													],
													listeners: {
														beforerender: {
															fn: me.onDetailsPanelsPortsBeforeRender,
															scope: me
														}
													}
												},
												{
													xtype: 'panel',
													id: 'detailsPanelsOthers',
													autoScroll: true,
													title: 'Others',
													layout: {
														type: 'vbox',
														align: 'stretch'
													},
													items: [
														{
															xtype: 'gridpanel',
															id: 'othersDetails',
															header: false,
															title: 'My Grid Panel',
															forceFit: true,
															hideHeaders: true,
															columns: [
																{
																	xtype: 'gridcolumn',
																	renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
																		return record.data.field1;
																	},
																	dataIndex: 'string',
																	text: 'Description'
																}
															],
															viewConfig: {
																disableSelection: true,
																emptyText: 'no Data avaliable',
																listeners: {
																	beforerender: {
																		fn: me.onViewBeforeRender41,
																		scope: me
																	}
																}
															}
														}
													],
													listeners: {
														beforerender: {
															fn: me.onDetailsPanelsOthersBeforeRender1,
															scope: me
														}
													}
												}
											],
											listeners: {
												beforerender: {
													fn: me.onDetailsPanelBeforeRender,
													scope: me
												}
											}
										}
									]
								},
								{
									xtype: 'container',
									height: 40,
									id: 'controlContainer',
									layout: {
										type: 'hbox',
										align: 'middle',
										padding: '0 10'
									},
									items: [
										{
											xtype: 'button',
											handler: function(button, event) {
												hostNames = [];

												grid = Ext.getCmp("discoveredElementsGrid").getSelectionModel();
												selected = grid.getSelection();
												for(i=0; i<selected.length; i++) {
													hostNames.push(selected[i].data.host_name);
												}

												if (hostNames.length === 0) {
													return;
												}

												Ext.Msg.confirm({
													buttons: Ext.MessageBox.OKCANCEL,
													title: l["Confirmation"],
													msg: l["Do you really want to apply all the changes ?"],
													fn: function(btn){
														if (btn !== 'ok') {
															return;
														}

														Ext.Ajax.request({
															url: '/opmon/seagull/www/index.php/discovery/action/discovery_jobs/',
															method: 'POST',
															params: {
																operation: 'delete_objects',
																hostnames_to_delete: JSON.stringify(hostNames)
															},
															success: function(result, request) {


																Discovery.getApplication().getHostDiscoveryDBStore().reload()
																Ext.Msg.confirm({
																	buttons: Ext.MessageBox.OK,
																	title: l["Confirmation"],
																	msg: l["Operation succeeded"]
																});
															},
															failure: function(result, request) {
																console.log(result);
																console.log(request);
															}
														});
													}

												});


											},
											cls: 'button-weak',
											disabled: true,
											id: 'removeElements',
											text: 'Remover elementos selecionados',
											listeners: {
												beforerender: {
													fn: me.onRemoveElementsBeforeRender,
													scope: me
												}
											}
										},
										{
											xtype: 'container',
											flex: 2,
											id: 'spacer007'
										},
										{
											xtype: 'button',
											handler: function(button, event) {
												var data = {
													hosts: [],
													callback: "Discovery.closeWindow"
												};
												var grid;
												var selected;
												var i;

												Discovery.closeWindow = function(success) {
													Discovery.detailsWindow.destroy();
												};

												grid = Ext.getCmp("discoveredElementsGrid").getSelectionModel();
												selected = grid.getSelection();
												for(i=0; i<selected.length; i++) {
													data.hosts.push(selected[i].data.host_name);
												}

												WIZZARD_CONFIG_PARAMS = data;

												Discovery.detailsWindow = new Ext.Window({
													title : l["Configuring hosts"],
													width : parseInt(window.innerWidth*0.93),
													height: parseInt(window.innerHeight*0.9),
													layout : 'fit',
													border: false,
													autoScroll: false,
													draggable: false,
													modal: true,
													resizable: false,
													items : [{
														xtype : "component",
														autoEl : {
															tag : "iframe",
															src : "/opmon/seagull/modules/discovery/templates/wizardext/app.php?"
														}
													}]
												}).show();
											},
											disabled: true,
											id: 'processBtn',
											text: 'Monitorar elementos selecionados',
											listeners: {
												beforerender: {
													fn: me.onProcessBtnBeforeRender,
													scope: me
												}
											}
										},
										{
											xtype: 'container',
											flex: 5,
											id: 'spacer006'
										}
									]
								}
							]
						},
						{
							xtype: 'panel',
							collapseMode: 'header',
							region: 'west',
							split: true,
							splitterResize: false,
							id: 'leftContent',
							width: 300,
							autoScroll: true,
							animCollapse: true,
							collapseFirst: false,
							collapsible: true,
							title: 'Configurações da Descoberta',
							layout: {
								type: 'vbox',
								align: 'stretch'
							},
							dockedItems: [
								{
									xtype: 'toolbar',
									flex: 1,
									dock: 'top',
									baseCls: 'x-container',
									id: 'add_new_discovery',
									items: [
										{
											xtype: 'button',
											flex: 1,
											height: 40,
											id: 'add_new_discovery_button',
											margin: '18 18 8 18',
											maxHeight: 40,
											padding: 0,
											text: 'Descobrir novo IP ou Range',
											listeners: {
												click: {
													fn: me.onAdd_new_discovery_buttonClick,
													scope: me
												},
												beforerender: {
													fn: me.onAdd_new_discovery_buttonBeforeRender,
													scope: me
												}
											}
										}
									]
								},
								{
									xtype: 'container',
									flex: 1,
									dock: 'left',
									id: 'tabElements',
									width: 300,
									autoScroll: true,
									layout: {
										type: 'vbox',
										align: 'stretch'
									},
									items: [
										{
											xtype: 'container',
											flex: 1,
											height: 50,
											id: 'rangesToProcessBtnCtn',
											maxHeight: 50,
											layout: {
												type: 'hbox',
												align: 'stretch',
												pack: 'end',
												padding: '0 18 25'
											},
											items: [
												{
													xtype: 'button',
													flex: 1,
													id: 'rangesToProcessBtn',
													text: 'Ver Ips e Ranges em processamento',
													listeners: {
														click: {
															fn: me.onButtonClick,
															scope: me
														},
														beforerender: {
															fn: me.onRangesToProcessBtnBeforeRender,
															scope: me
														}
													}
												}
											]
										},
										{
											xtype: 'container',
											id: 'sendIpPanel',
											width: 300,
											layout: 'column'
										},
										{
											xtype: 'panel',
											flex: 1,
											height: 36,
											hidden: true,
											id: 'rangesToProcessPanel',
											margin: '0 0 18',
											padding: '0 18',
											autoScroll: true,
											bodyPadding: '0 0 15',
											animCollapse: false,
											closable: true,
											closeAction: 'hide',
											collapsed: false,
											collapsible: false,
											title: 'Ips e Ranges a serem processados',
											items: [
												{
													xtype: 'dataview',
													cls: 'x-accordion-item',
													frame: false,
													id: 'listIPelements',
													padding: 15,
													autoScroll: true,
													emptyText: 'Não há IPs ou ranges a serem processados',
													itemCls: 'x-dataview-item x-accordion-hd',
													itemSelector: 'div',
													itemTpl: [
														'<span class=\'ip-item\'><span class=\'ip-item-left\'>{mask} </span></span>'
													],
													loadingCls: 'loading-ip',
													overItemCls: 'x-accordion-hd-over',
													store: 'DiscoveryJobDB',
													listeners: {
														select: {
															fn: me.onListIPelementsSelect,
															scope: me
														},
														beforerender: {
															fn: me.onListIPelementsBeforeRender,
															scope: me
														}
													}
												}
											],
											listeners: {
												beforerender: {
													fn: me.onRangesToProcessPanelBeforeRender,
													scope: me
												},
												close: {
													fn: me.onRangesToProcessPanelClose,
													scope: me
												}
											}
										},
										{
											xtype: 'panel',
											flex: 1,
											id: 'tabSnmp',
											margin: '0 18',
											layout: 'card',
											animCollapse: false,
											collapsed: false,
											collapsible: true,
											title: 'Autenticações cadastradas',
											items: [
												{
													xtype: 'panel',
													cls: 'tab-sub-header',
													id: 'listSnmp',
													autoScroll: true,
													header: false,
													title: 'Comunidades SNMP',
													layout: {
														type: 'vbox',
														align: 'stretch'
													},
													items: [
														{
															xtype: 'panel',
															id: 'addedCommunities',
															margin: 15,
															bodyPadding: '0 0 15',
															collapsed: false,
															collapsible: false,
															header: false,
															title: 'Comunidades adicionadas',
															items: [
																{
																	xtype: 'dataview',
																	cls: 'x-accordion-item',
																	frame: false,
																	id: 'list-snmp-elements',
																	padding: 0,
																	emptyText: 'Não há comunidade SNMP adicionada',
																	itemCls: 'x-dataview-item x-accordion-hd',
																	itemSelector: 'div',
																	itemTpl: [
																		'<tpl if="snmp_version == \'3\'">',
																		'	<span class=\'snmp-item\'><span class=\'snmp-item-left length12\'>{security_username}</span><span class=\'snmp-item-right\'>SNMP v{snmp_version}</span></span>',
																		'</tpl>',
																		'',
																		'<tpl if="snmp_version == \'1\'">',
																		'	<span class=\'snmp-item\'><span class=\'snmp-item-left length12\'>{community}</span><span class=\'snmp-item-right\'>SNMP v{snmp_version}</span></span>',
																		'</tpl>',
																		'',
																		'<tpl if="snmp_version == \'2c\'">',
																		'	<span class=\'snmp-item\'><span class=\'snmp-item-left length12\'>{community}</span><span class=\'snmp-item-right\'>SNMP v{snmp_version}</span></span>',
																		'</tpl>',
																		'',
																		'<tpl if="snmp_version == \'credentials\'">',
																		'	<span class=\'snmp-item\'><span class=\'snmp-item-left length12\'>{credential_user}</span><span class=\'snmp-item-right\'>User and Pass</span></span>',
																		'</tpl>'
																	],
																	overItemCls: 'x-accordion-hd-over',
																	store: 'SNMPCommunityDB',
																	listeners: {
																		select: {
																			fn: me.processSelect,
																			scope: me
																		},
																		afterrender: {
																			fn: me.toolTip,
																			scope: me
																		}
																	}
																}
															],
															listeners: {
																beforerender: {
																	fn: me.onAddedCommunitiesBeforeRender,
																	scope: me
																}
															}
														}
													],
													dockedItems: [
														{
															xtype: 'toolbar',
															flex: 1,
															dock: 'bottom',
															padding: 0,
															items: [
																{
																	xtype: 'container',
																	flex: 1,
																	maxWidth: 264,
																	minWidth: 264,
																	width: 264,
																	layout: {
																		type: 'hbox',
																		align: 'stretch'
																	},
																	items: [
																		{
																			xtype: 'button',
																			flex: 1,
																			id: 'addSnmp',
																			itemId: 'nextBtn',
																			margin: 15,
																			text: 'Cadastrar nova autenticação',
																			listeners: {
																				beforerender: {
																					fn: me.onAddSnmpBeforeRender,
																					scope: me
																				}
																			}
																		}
																	]
																}
															]
														}
													]
												},
												{
													xtype: 'form',
													cls: 'tab-sub-header',
													id: 'formSnmp',
													itemId: 'formSnmp',
													autoScroll: true,
													header: false,
													title: 'Definir os parâmetros da Comunidade',
													titleCollapse: false,
													layout: {
														type: 'vbox',
														align: 'stretch',
														padding: '15 15 40 15'
													},
													items: [
														{
															xtype: 'fieldset',
															id: 'formSnmpVersion',
															items: [
																{
																	xtype: 'combobox',
																	anchor: '100%',
																	id: 'formSnmpVersionSelect',
																	fieldLabel: 'Tipo de autenticação',
																	name: 'snmp_version',
																	store: [
																		[
																			'1',
																			'SNMP v1'
																		],
																		[
																			'2c',
																			'SNMP v2c'
																		],
																		[
																			'3',
																			'SNMP v3'
																		],
																		[
																			'credentials',
																			'User and Password'
																		]
																	],
																	listeners: {
																		change: {
																			fn: me.onFormSnmpVersionSelectChange,
																			scope: me
																		},
																		beforerender: {
																			fn: me.onFormSnmpVersionSelectBeforeRender,
																			scope: me
																		}
																	}
																}
															],
															listeners: {
																beforerender: {
																	fn: me.onFormSnmpVersionBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'fieldset',
															id: 'formSnmpAuth',
															width: 338,
															title: 'teste',
															items: [
																{
																	xtype: 'textfield',
																	anchor: '100%',
																	id: 'formSnmpAuthCommunity',
																	fieldLabel: 'Comunidade',
																	name: 'community',
																	enforceMaxLength: false,
																	listeners: {
																		beforerender: {
																			fn: me.onFormSnmpAuthCommunityBeforeRender,
																			scope: me
																		}
																	}
																},
																{
																	xtype: 'textfield',
																	anchor: '100%',
																	hidden: true,
																	id: 'formCredentialUser',
																	fieldLabel: 'Usuário',
																	name: 'credential_user',
																	enforceMaxLength: false,
																	listeners: {
																		beforerender: {
																			fn: me.onFormSnmpAuthCommunityBeforeRender1,
																			scope: me
																		}
																	}
																},
																{
																	xtype: 'textfield',
																	anchor: '100%',
																	hidden: true,
																	id: 'formCredentialPass',
																	fieldLabel: 'Senha',
																	name: 'credential_pass',
																	listeners: {
																		beforerender: {
																			fn: me.onFormSnmpAuthCommunityBeforeRender11,
																			scope: me
																		}
																	}
																},
																{
																	xtype: 'combobox',
																	anchor: '100%',
																	hidden: true,
																	id: 'formSnmpAuthProtocol',
																	fieldLabel: 'Protocolo',
																	name: 'authentication_protocol',
																	store: [
																		'SHA',
																		'MD5'
																	],
																	listeners: {
																		beforerender: {
																			fn: me.onFormSnmpAuthProtocolBeforeRender,
																			scope: me
																		}
																	}
																},
																{
																	xtype: 'textfield',
																	anchor: '100%',
																	hidden: true,
																	id: 'formSnmpAuthPass',
																	fieldLabel: 'Senha',
																	name: 'authentication_passphrase',
																	listeners: {
																		beforerender: {
																			fn: me.onFormSnmpAuthPassBeforeRender,
																			scope: me
																		}
																	}
																}
															],
															listeners: {
																beforerender: {
																	fn: me.onFormSnmpAuthBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'fieldset',
															hidden: true,
															id: 'formSnmpSecurity',
															width: 150,
															title: 'Segurança',
															items: [
																{
																	xtype: 'combobox',
																	anchor: '100%',
																	id: 'formSnmpSecurityLevel',
																	fieldLabel: 'Level',
																	name: 'security_level',
																	store: [
																		'authPriv',
																		'authNoPriv',
																		'noAuthNoPriv'
																	],
																	listeners: {
																		beforerender: {
																			fn: me.onFormSnmpSecurityLevelBeforeRender,
																			scope: me
																		}
																	}
																},
																{
																	xtype: 'textfield',
																	anchor: '100%',
																	id: 'formSnmpSecurityContext',
																	fieldLabel: 'Contexto',
																	name: 'context_name',
																	listeners: {
																		beforerender: {
																			fn: me.onFormSnmpSecurityContextBeforeRender,
																			scope: me
																		}
																	}
																},
																{
																	xtype: 'textfield',
																	anchor: '100%',
																	id: 'formSnmpSecurityUser',
																	fieldLabel: 'Usuário',
																	name: 'security_username',
																	enforceMaxLength: false,
																	maxLengthText: '',
																	listeners: {
																		beforerender: {
																			fn: me.onFormSnmpSecurityUserBeforeRender,
																			scope: me
																		}
																	}
																}
															],
															listeners: {
																beforerender: {
																	fn: me.onFormSnmpSecurityBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'fieldset',
															height: 107,
															hidden: true,
															id: 'formSnmpPrivacy',
															title: 'Privacidade',
															items: [
																{
																	xtype: 'combobox',
																	anchor: '100%',
																	id: 'formSnmpPrivacyProtocol',
																	fieldLabel: 'Protocolo',
																	name: 'privacy_protocol',
																	store: [
																		'AES',
																		'DES'
																	],
																	listeners: {
																		beforerender: {
																			fn: me.onFormSnmpPrivacyProtocolBeforeRender,
																			scope: me
																		}
																	}
																},
																{
																	xtype: 'textfield',
																	anchor: '100%',
																	id: 'formSnmpPrivacyPass',
																	fieldLabel: 'Senha',
																	name: 'privacy_protocol_passphrase',
																	listeners: {
																		beforerender: {
																			fn: me.onFormSnmpPrivacyPassBeforeRender,
																			scope: me
																		}
																	}
																},
																{
																	xtype: 'textfield',
																	anchor: '100%',
																	id: 'formSnmpPrivacyDestiny',
																	fieldLabel: 'Destino',
																	name: 'destination_engine',
																	listeners: {
																		beforerender: {
																			fn: me.onFormSnmpPrivacyDestinyBeforeRender,
																			scope: me
																		}
																	}
																}
															],
															listeners: {
																beforerender: {
																	fn: me.onFormSnmpPrivacyBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'container',
															flex: 1,
															id: 'formSnmpButtons',
															layout: 'column',
															items: [
																{
																	xtype: 'container',
																	columnWidth: 0.7,
																	id: 'formSnmpCancelContainer',
																	items: [
																		{
																			xtype: 'button',
																			cls: 'button-weak',
																			height: 30,
																			id: 'formSnmpCancel',
																			text: 'Cancelar',
																			listeners: {
																				click: {
																					fn: me.onFormSnmpCancelClick,
																					scope: me
																				},
																				beforerender: {
																					fn: me.onFormSnmpCancelBeforeRender,
																					scope: me
																				}
																			}
																		}
																	]
																},
																{
																	xtype: 'button',
																	columnWidth: 0.3,
																	height: 30,
																	id: 'formSnmpSave',
																	text: 'Salvar',
																	listeners: {
																		click: {
																			fn: me.onFormSnmpSaveClick,
																			scope: me
																		},
																		beforerender: {
																			fn: me.onFormSnmpSaveBeforeRender,
																			scope: me
																		}
																	}
																}
															]
														}
													],
													tools: [
														{
															xtype: 'tool',
															id: 'helpFormSnmp',
															tooltip: 'Ajuda',
															type: 'help'
														}
													],
													listeners: {
														show: {
															fn: me.onFormSnmpShow,
															scope: me
														}
													}
												}
											],
											listeners: {
												beforerender: {
													fn: me.onTabSnmpBeforeRender,
													scope: me
												}
											}
										},
										{
											xtype: 'panel',
											id: 'tabOptions',
											margin: 18,
											width: 150,
											autoScroll: true,
											bodyPadding: 20,
											animCollapse: false,
											collapsed: true,
											collapsible: true,
											title: 'Opções Avançadas',
											items: [
												{
													xtype: 'checkboxfield',
													id: 'autoDiscovery',
													boxLabel: 'Descoberta Automática Acionada',
													listeners: {
														added: {
															fn: me.onAutoDiscoveryAdded,
															scope: me
														},
														change: {
															fn: me.onAutoDiscoveryChange,
															scope: me
														},
														beforerender: {
															fn: me.onAutoDiscoveryBeforeRender,
															scope: me
														}
													}
												}
											],
											listeners: {
												beforerender: {
													fn: me.onTabOptionsBeforeRender,
													scope: me
												}
											}
										}
									]
								}
							],
							listeners: {
								beforerender: {
									fn: me.onLeftContentBeforeRender,
									scope: me
								}
							}
						}
					]
				},
				{
					xtype: 'container',
					cls: 'top_bar',
					height: 45,
					id: 'bottomNav',
					padding: 10,
					fixed: true,
					layout: {
						type: 'hbox',
						align: 'stretch'
					},
					items: [
						{
							xtype: 'button',
							handler: function(button, event) {
								window.location.href = "/opmon/";
							},
							cls: 'button-weak-bg',
							id: 'cancelProcess',
							glyph: 215,
							text: 'Cancelar o processo e ir para o gerenciamento',
							listeners: {
								beforerender: {
									fn: me.onCancelProcessBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'container',
							flex: 1,
							id: 'bottomNavCancelContainer'
						},
						{
							xtype: 'button',
							handler: function(button, event) {
								Ext.getCmp('mainView').getLayout().setActiveItem('topologyView');
							},
							id: 'proceedProcess',
							text: 'Gerar topologia de rede',
							listeners: {
								beforerender: {
									fn: me.onProceedProcessBeforeRender,
									scope: me
								}
							}
						}
					]
				}
			]
		});

		me.callParent(arguments);
	},

	onHeaderTitle4BeforeRender: function(component, eOpts) {
		component.html  = "<h4 class='header-title'>";
		component.html += l["OpMon initial setup"];
		component.html += "</h4>";
	},

	onBreadBtnStep13BeforeRender: function(component, eOpts) {
		component.text = l["Set the administrator password"];
	},

	onBreadBtnStep14BeforeRender: function(component, eOpts) {
		component.text = l["Discovering network elements"];
	},

	onBreadBtnStep15BeforeRender: function(component, eOpts) {
		component.text = l["Generate network topology"];
	},

	onFake_header_panelBeforeRender: function(component, eOpts) {
		component.title = l["Discovered Elements"];
	},

	onTextfieldKeyup: function(textfield, e, eOpts) {
		Discovery.filterValue = textfield.getValue();

		if (Discovery.filter_timeout !== null) {
			clearTimeout(Discovery.filter_timeout);
			Discovery.filter_timeout = null;
		}

		Discovery.filter_timeout = setTimeout(Discovery.getApplication().getViewControllerController().applyFilter,900);
	},

	onTriggerfieldBeforeRender: function(component, eOpts) {
		component.emptyText = l["Filter discovered elements"];
	},

	onProcessSectionAfterRender: function(component, eOpts) {
		var myMask = new Ext.LoadMask(component, {msg:l['Active Discovery activated'], alignTarget: Ext.getCmp('process_spacer'), maxWidth: 263, shadow: false, shadowOffset: 0, floating: true, cls: 'discovery-loader', frame: false, id: 'loadProcess', maskCls: 'load-mask'});
		myMask.show();
	},

	onGridcolumnBeforeRender: function(component, eOpts) {
		component.text = l["Host Name"];
	},

	onGridcolumnBeforeRender1: function(component, eOpts) {
		component.text = l["IP Address"];
	},

	onGridcolumnBeforeRender2: function(component, eOpts) {
		component.text = l["Description"];
	},

	onViewCellClick: function(tableview, td, cellIndex, record, tr, rowIndex, e, eOpts) {
		var disksDetails;
		var processesDetails;
		var portDetails;
		var servicesDetails;
		var detailsPanel;
		var othersPanel;


		var detailPanel = Ext.getCmp("detailsPanel");

		Ext.create('Ext.fx.Anim', {
		    target: detailPanel,
		    duration: 500,
		    from: {
		        opacity: 0,       // Transparent
		    },
		    to: {
		        opacity: 1,       // Transparent
		    }
		});

		detailPanel.show();



		detailsPanel = Discovery.getApplication().getViewControllerController().getDetailsPanel();
		detailsPanel.setTitle("Details of " + record.data.host_name);

		disksDetails = Discovery.getApplication().getViewControllerController().getDisksDetails();
		disksDetails.reconfigure(record.data.disks);

		processesDetails = Discovery.getApplication().getViewControllerController().getProcessesDetails();
		processesDetails.reconfigure(record.data.processes);

		portDetails = Discovery.getApplication().getViewControllerController().getPortDetails();
		portDetails.reconfigure(record.data.open_ports);

		servicesDetails = Discovery.getApplication().getViewControllerController().getServicesDetails();
		servicesDetails.reconfigure(record.data.services);

		interfacesDetails = Discovery.getApplication().getViewControllerController().getInterfacesDetails();
		interfacesDetails.reconfigure(record.data.network_interfaces);

		othersPanel = Discovery.getApplication().getViewControllerController().getOthersDetails();
		othersPanel.reconfigure(record.data.others);
	},

	onViewItemMouseEnter: function(dataview, record, item, index, e, eOpts) {
		var infotip = Ext.create('Ext.tip.ToolTip', {
		    target: item,
		    html: l['Click to see the element details']
		});
	},

	onCheckboxModelSelectionChange: function(model, selected, eOpts) {
		countSelected = selected.length;
		document.getElementById('nSelectedElements').innerHTML = countSelected;
		if (countSelected > 0) {
			Ext.getCmp('processBtn').setDisabled(false);
			Ext.getCmp('removeElements').setDisabled(false);
		} else {
			Ext.getCmp('processBtn').setDisabled(true);
			Ext.getCmp('removeElements').setDisabled(true);
		}
	},

	onPagingtoolbarBeforeRender: function(component, eOpts) {
		component.afterPageText = l["of"]+ " {0}";
	},

	onElementCounterBeforeRender: function(component, eOpts) {
		component.html  = "<p id='rightP'><span id='nSelectedElements'>0</span> "+l['Element (s) selected (s)']+"</p>"
	},

	onViewBeforeRender: function(component, eOpts) {
		component.emptyText = l["No data available"];
	},

	onDetailsPanelsDisksBeforeRender: function(component, eOpts) {
		component.title = l["HDs"];
	},

	onViewBeforeRender1: function(component, eOpts) {
		component.emptyText = l["No data available"];
	},

	onDetailsPanelsInterfacesBeforeRender: function(component, eOpts) {
		component.title = "Interfaces";
	},

	onViewBeforeRender2: function(component, eOpts) {
		component.emptyText = l["No data available"];
	},

	onDetailsPanelsProcessesBeforeRender: function(component, eOpts) {
		component.title = l["Processes"];
	},

	onViewBeforeRender3: function(component, eOpts) {
		component.emptyText = l["No data available"];
	},

	onDetailsPanelsServicesBeforeRender: function(component, eOpts) {
		component.title = l["Services"];
	},

	onViewBeforeRender4: function(component, eOpts) {
		component.emptyText = l["No data available"];
	},

	onDetailsPanelsPortsBeforeRender: function(component, eOpts) {
		component.title = l["Ports"];
	},

	onViewBeforeRender41: function(component, eOpts) {
		component.emptyText = l["No data available"];
	},

	onDetailsPanelsOthersBeforeRender1: function(component, eOpts) {
		component.title = l["Others"];
	},

	onDetailsPanelBeforeRender: function(component, eOpts) {
		component.title = l["Details"];
	},

	onRemoveElementsBeforeRender: function(component, eOpts) {
		component.text = l["Remove selected elements"];
	},

	onProcessBtnBeforeRender: function(component, eOpts) {
		component.text = l["Add selected elements"];
	},

	onAdd_new_discovery_buttonClick: function(button, e, eOpts) {
		Ext.create('Discovery.view.addNewDiscovery').show();
	},

	onAdd_new_discovery_buttonBeforeRender: function(component, eOpts) {
		component.text = l["Discover new IP or Range"];
	},

	onButtonClick: function(button, e, eOpts) {
		Ext.getCmp('rangesToProcessPanel').show();
		Ext.getCmp('rangesToProcessBtnCtn').hide();
	},

	onRangesToProcessBtnBeforeRender: function(component, eOpts) {
		component.text = l["See Ips and Ranges to be processed"];
	},

	onListIPelementsSelect: function(dataviewmodel, record, eOpts) {
		var e;
		var i;

		if (Discovery.ipContextMenu !== undefined) {
			Discovery.ipContextMenu.destroy();
		}

		Discovery.ipContextMenu = Ext.create('Discovery.view.SnmpMenu', {
			cancelJob: record,
			items: [
			{
				text: 'Cancel',
				listeners: {
					click:  function(button) {

						var job;

						job = Discovery.ipContextMenu.cancelJob;

						Ext.Ajax.request({
							method: "POST",
							params: {
								operation: "cancel",
								job_id: job.data.id
							},
							url: "/opmon/seagull/www/index.php/discovery/action/discovery_jobs/",
							success: function(result, request) {

								var ret = JSON.parse(result.responseText);
								if (!ret.success) {
									Ext.MessageBox.show({
										title: l["Error"],
										msg: ret.message,
										icon: Ext.MessageBox.ERROR
									});
									return;
								}

								Ext.MessageBox.show({
									title: l["Success"],
									msg: l["Process canceled successfully"],
									icon: Ext.MessageBox.INFO,
									closable: false
								});
								setTimeout(function(){Ext.MessageBox.hide();},2000);

							}

						});

					}
				}
			}
			]
		});

		for (i=0; i<dataviewmodel.view.all.elements.length; i++) {
			e = dataviewmodel.view.all.elements[i];
			if (e.attributes['class'].nodeValue.indexOf("selected") != -1) {
				Discovery.ipContextMenu.show();
				Discovery.ipContextMenu.anchorTo(e);
				return;
			}
		}
	},

	onListIPelementsBeforeRender: function(component, eOpts) {
		component.emptyText = l["No IPs or ranges to be processed"];
	},

	onRangesToProcessPanelBeforeRender: function(component, eOpts) {
		component.title = l["Ips and Ranges to be processed"];
	},

	onRangesToProcessPanelClose: function(panel, eOpts) {
		Ext.getCmp('rangesToProcessBtnCtn').show();
	},

	processSelect: function(dataviewmodel, record, eOpts) {
		var e;
		var i;
		if (record === null || record === undefined) {
			return;
		}

		Discovery.getApplication().getViewControllerController().communityBeingEditted = record;
		if (Discovery.commContextMenu !== undefined) {
			Discovery.commContextMenu.destroy();
		}

		Discovery.commContextMenu = Ext.create('Discovery.view.SnmpMenu', {
			items: [
				{
					text: l['Edit'],
					listeners: {
						click:  function(button) {

							var controller = Discovery.getApplication().getViewControllerController();
							var comm = controller.communityBeingEditted;
							var form = controller.getFormSnmp();
							var tabSnmp = controller.getTabSnmp();
							var simpleForm = form.getForm();

							tabSnmp.layout.setActiveItem('formSnmp');
							simpleForm.loadRecord(comm);
						}
					}
				},
				{
					text: l['Remove'],
					listeners: {
						click: function(button) {
							var controller = Discovery.getApplication().getViewControllerController();
							var comm = controller.communityBeingEditted;
							var store = controller.getSNMPCommunityDBStore();

							var comm_index;

							if (comm.data.snmp_version != 'credentials') {
								comm_index = store.find("community_id", comm.data.community_id);
							} else {
								comm_index = store.find("credential_id", comm.data.credential_id);
							}

							store.removeAt(comm_index);
							store.sync({
								failure: function(batch, options) {
									var response = batch.proxy.getReader().rawData;
									var message = response.message;
									var hosts = "";
									if (response.message.indexOf(':') > 0) {
										var tempArray = response.message.split(':');
										message = l[tempArray[0]];

										// This test is needed to guarantee that variable message is not undefined
										message = message || 'This authentication cannot be removed because is used by the following hosts';

										hosts = ": " + tempArray[1];
									}

									Ext.MessageBox.show({
										title: l["Request Status"],
										msg: message + hosts,
										icon: Ext.MessageBox.ERROR,
										closable: true
									});
									store.reload();
								}
							});
						}
					}
				}
			]
		});


		for (i=0; i<dataviewmodel.view.all.elements.length; i++) {
			e = dataviewmodel.view.all.elements[i];
			if (e.attributes['class'].nodeValue.indexOf("selected") != -1) {
				Discovery.commContextMenu.show();
				Discovery.commContextMenu.anchorTo(e);
				return;
			}
		}
	},

	toolTip: function(component, eOpts) {
		component.tip = Ext.create('Ext.tip.ToolTip', {

			target: component.el,
			delegate: component.itemSelector,
			trackMouse:true,
			renderTo: Ext.getBody(),
			listeners: {

				beforeshow: function updateTipBody(tip) {
					var record = component.getRecord(tip.triggerElement);
					var credential = record.get('credential_id');
					var community = record.get('community_id');
					var communityName = record.get('community');
					var credentialName= record.get('credential_user');
					var snmpVersionName = record.get('security_username');
					var text = 'Community ID: ' + community + '<br/>' + 'Auth Name: ' + communityName;

					if (credential === community) {

						text = 'Credential ID: ' + credential + '<br/>'+ 'Auth Name: ' + credentialName;

					}else if(snmpVersionName!==null){

						text = 'Community ID: ' + community + '<br/>' + 'Auth Name: ' + snmpVersionName ;
					}


				    tip.update(text);
				}
			}
		});
	},

	onAddedCommunitiesBeforeRender: function(component, eOpts) {
		component.title = l["Communities added"];
	},

	onAddSnmpBeforeRender: function(component, eOpts) {
		component.text = l["Register new authentication"];
	},

	onFormSnmpVersionSelectChange: function(field, newValue, oldValue, eOpts) {
		if (newValue === '3') {
			Ext.getCmp('formSnmpAuthCommunity').setVisible(false);
			Ext.getCmp('formSnmpAuthProtocol').setVisible(true);
			Ext.getCmp('formSnmpAuthPass').setVisible(true);
			Ext.getCmp('formSnmpSecurity').setVisible(true);
			Ext.getCmp('formSnmpPrivacy').setVisible(true);
			Ext.getCmp('formCredentialUser').setVisible(false);
			Ext.getCmp('formCredentialPass').setVisible(false);
		} else if (newValue === 'credentials') {
			Ext.getCmp('formSnmpAuthCommunity').setVisible(false);
			Ext.getCmp('formSnmpAuthProtocol').setVisible(false);
			Ext.getCmp('formSnmpAuthPass').setVisible(false);
			Ext.getCmp('formSnmpSecurity').setVisible(false);
			Ext.getCmp('formSnmpPrivacy').setVisible(false);
			Ext.getCmp('formCredentialUser').setVisible(true);
			Ext.getCmp('formCredentialPass').setVisible(true);
		} else {
			Ext.getCmp('formSnmpAuthCommunity').setVisible(true);
			Ext.getCmp('formSnmpAuthProtocol').setVisible(false);
			Ext.getCmp('formSnmpAuthPass').setVisible(false);
			Ext.getCmp('formSnmpSecurity').setVisible(false);
			Ext.getCmp('formSnmpPrivacy').setVisible(false);
			Ext.getCmp('formCredentialUser').setVisible(false);
			Ext.getCmp('formCredentialPass').setVisible(false);
		}
	},

	onFormSnmpVersionSelectBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Authentication Mode"];
	},

	onFormSnmpVersionBeforeRender: function(component, eOpts) {
		component.setTitle(l["Authentication Mode"]);
	},

	onFormSnmpAuthCommunityBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Community"];
	},

	onFormSnmpAuthCommunityBeforeRender1: function(component, eOpts) {
		component.fieldLabel = l["User"];
	},

	onFormSnmpAuthCommunityBeforeRender11: function(component, eOpts) {
		component.fieldLabel = l["Password"];
	},

	onFormSnmpAuthProtocolBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Protocol"];
	},

	onFormSnmpAuthPassBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Password"];
	},

	onFormSnmpAuthBeforeRender: function(component, eOpts) {
		component.setTitle(l["Authentication"]);
	},

	onFormSnmpSecurityLevelBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Level"];
	},

	onFormSnmpSecurityContextBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Context"];
	},

	onFormSnmpSecurityUserBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["User"];
	},

	onFormSnmpSecurityBeforeRender: function(component, eOpts) {
		component.setTitle(l["Security"]);
	},

	onFormSnmpPrivacyProtocolBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Protocol"];
	},

	onFormSnmpPrivacyPassBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Password"];
	},

	onFormSnmpPrivacyDestinyBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Destination"];
	},

	onFormSnmpPrivacyBeforeRender: function(component, eOpts) {
		component.setTitle(l["Privacy"]);
	},

	onFormSnmpCancelClick: function(button, e, eOpts) {
		//this.items.map.content.items.map.leftContent.items.map.tabSnmp.layout.setActiveItem('listSnmp');
	},

	onFormSnmpCancelBeforeRender: function(component, eOpts) {
		component.text = l["Cancel"];
	},

	onFormSnmpSaveClick: function(button, e, eOpts) {
		//Ext.MessageBox.alert('Nova comunidade','Registro efetuado com sucesso');
		//this.items.map.content.items.map.leftContent.items.map.tabSnmp.layout.setActiveItem('listSnmp');
	},

	onFormSnmpSaveBeforeRender: function(component, eOpts) {
		component.text = l["Save"];
	},

	onFormSnmpShow: function(component, eOpts) {
		var versionValue = Ext.getCmp('formSnmpVersionSelect').value;
		if (versionValue === '3') {
			Ext.getCmp('formSnmpAuthCommunity').setVisible(false);
			Ext.getCmp('formSnmpAuthProtocol').setVisible(true);
			Ext.getCmp('formSnmpAuthPass').setVisible(true);
			Ext.getCmp('formSnmpSecurity').setVisible(true);
			Ext.getCmp('formSnmpPrivacy').setVisible(true);
		} else {
			Ext.getCmp('formSnmpAuthCommunity').setVisible(true);
			Ext.getCmp('formSnmpAuthProtocol').setVisible(false);
			Ext.getCmp('formSnmpAuthPass').setVisible(false);
			Ext.getCmp('formSnmpSecurity').setVisible(false);
			Ext.getCmp('formSnmpPrivacy').setVisible(false);
		}
	},

	onTabSnmpBeforeRender: function(component, eOpts) {
		component.title = l["Registered Authentications"];
	},

	onAutoDiscoveryAdded: function(component, container, pos, eOpts) {

		Ext.Ajax.request({
			method: "GET",
			url: "/opmon/seagull/www/index.php/discovery/action/auto_discovery/",
			success: function(result, request) {

				var ret = JSON.parse(result.responseText);
				if (!ret.success) {
					console.log(result.responseText);
					return;
				}

				var status = (ret.auto_discovery_status === "1") ? true : false;
				var discovery = Discovery.getApplication().getViewControllerController();
				var cb = discovery.getAutoDiscoveryCheckBox();
				cb.setValue(status);

			}

		});
	},

	onAutoDiscoveryChange: function(field, newValue, oldValue, eOpts) {

		Ext.Ajax.request({
			method: "POST",
			url: "/opmon/seagull/www/index.php/discovery/action/auto_discovery/",
			params: {
				operation: "set",
				status: (newValue) ? "1" : "0"
			},
			success: function(result, request) {

				var ret = JSON.parse(result.responseText);
				if (!ret.success) {
					console.log(result.responseText);
					return;
				}

				var status = (ret.auto_discovery_status === "1") ? true : false;
				var discovery = Discovery.getApplication().getViewControllerController();
				var cb = discovery.getAutoDiscoveryCheckBox();
				cb.setValue(status);

			}

		});
	},

	onAutoDiscoveryBeforeRender: function(component, eOpts) {
		component.boxLabel = l["Autodiscover Active"];
	},

	onTabOptionsBeforeRender: function(component, eOpts) {
		component.title = l["Advanced Options"];
	},

	onLeftContentBeforeRender: function(component, eOpts) {
		component.title = l["Discovery Configuration"];
	},

	onCancelProcessBeforeRender: function(component, eOpts) {
		component.text = l["Finish Wizard and go to OpMon"];
		//Cancelar o processo e ir para o gerenciamento
	},

	onProceedProcessBeforeRender: function(component, eOpts) {
		component.text = l["Generate network topology"];
	}

});