/*
 * File: app/view/passwordView.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Discovery.view.passwordView', {
	extend: 'Ext.container.Container',
	alias: 'widget.passwordview',

	requires: [
		'Ext.form.Panel',
		'Ext.form.Label',
		'Ext.form.field.Text',
		'Ext.button.Button'
	],

	id: 'passwordView',
	minWidth: 940,

	layout: {
		type: 'vbox',
		align: 'stretch'
	},

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'container',
					flex: 1,
					cls: 'x-panel-header-default',
					id: 'content3',
					layout: {
						type: 'hbox',
						align: 'stretch'
					},
					items: [
						{
							xtype: 'container',
							flex: 1,
							width: 150
						},
						{
							xtype: 'container',
							id: 'leftContent2',
							layout: {
								type: 'hbox',
								align: 'stretch'
							},
							items: [
								{
									xtype: 'container',
									flex: 1,
									id: 'rightContent3',
									width: 600,
									layout: {
										type: 'vbox',
										align: 'center'
									},
									items: [
										{
											xtype: 'container',
											flex: 1
										},
										{
											xtype: 'form',
											cls: 'stepBox',
											id: 'adminData1',
											maxWidth: 241,
											minWidth: 241,
											width: 241,
											bodyPadding: 20,
											collapseDirection: 'right',
											collapsible: false,
											title: 'Defina a senha e o e-mail',
											layout: {
												type: 'vbox',
												align: 'stretch'
											},
											items: [
												{
													xtype: 'label',
													text: 'Usuário administrador',
													listeners: {
														beforerender: {
															fn: me.onLabelBeforeRender1,
															scope: me
														}
													}
												},
												{
													xtype: 'label',
													cls: 'bold italic',
													text: 'opmonadmin'
												},
												{
													xtype: 'textfield',
													flex: 1,
													margins: '10 0 0',
													id: 'password',
													maxHeight: 40,
													fieldLabel: 'Defina a senha',
													labelAlign: 'top',
													labelSeparator: ' ',
													inputType: 'password',
													listeners: {
														beforerender: {
															fn: me.onPasswordBeforeRender,
															scope: me
														}
													}
												},
												{
													xtype: 'textfield',
													flex: 1,
													margins: '10 0 0',
													id: 'passwordConfirmation',
													maxHeight: 40,
													fieldLabel: 'Repita a senha',
													labelAlign: 'top',
													labelSeparator: ' ',
													inputType: 'password',
													listeners: {
														beforerender: {
															fn: me.onPasswordConfirmationBeforeRender,
															scope: me
														}
													}
												},
												{
													xtype: 'textfield',
													flex: 1,
													margins: '10 0 0',
													id: 'email',
													maxHeight: 40,
													fieldLabel: 'Defina o e-mail',
													labelAlign: 'top',
													labelSeparator: ' ',
													listeners: {
														beforerender: {
															fn: me.onEmailBeforeRender,
															scope: me
														}
													}
												},
												{
													xtype: 'button',
													height: 30,
													margin: '20 0 0 0',
													maxHeight: 30,
													minHeight: 30,
													text: 'Começar a configuração',
													listeners: {
														click: {
															fn: me.onButtonClick,
															scope: me
														},
														afterrender: {
															fn: me.onButtonAfterRender,
															scope: me
														}
													}
												}
											],
											listeners: {
												afterrender: {
													fn: me.onAdminData1AfterRender,
													scope: me
												}
											}
										},
										{
											xtype: 'container',
											flex: 1
										}
									]
								}
							]
						},
						{
							xtype: 'container',
							flex: 1
						}
					]
				}
			]
		});

		me.callParent(arguments);
	},

	onLabelBeforeRender1: function(component, eOpts) {
		component.text = l["User administrator"];
	},

	onPasswordBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Set the password"];
	},

	onPasswordConfirmationBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Repeat the password"];
	},

	onEmailBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Set the e- mail"];
	},

	onButtonClick: function(button, e, eOpts) {
		var controller;
		var field;
		var password = [];
		var email;

		controller = Discovery.getApplication().getViewControllerController();

		field = controller.getPassword();
		password.push(field.getValue());
		field = controller.getPasswordConfirmation();
		password.push(field.getValue());

		field = controller.getEmail();
		email = field.getValue();


		if (password[0] != password[1] || password[0] == "") {
			controller.getPassword().setActiveError(l["Passwords does not match"]);
			controller.getPasswordConfirmation().setActiveError(l["Passwords does not match"]);
			return false;
		}

		if (email == "") {
			controller.getEmail().setActiveError(l["Set the e- mail"]);
			return false;
		}


		Ext.Ajax.request({
			method: "POST",
			url: "/opmon/seagull/www/index.php/opinterface/action/change_opmonadmin_pass/",
			params: {
				pass: password[0],
				email: email
			},
			success: function(result, request) {

				var res;

				res = JSON.parse(result.responseText);

				if (document.selected_module === 'traffic') {
					Ext.get('traffic_component').dom.src = "/opmon/seagull/modules/traffic/templates/index.php";
					Ext.getCmp('mainView').getLayout().setActiveItem('traffic_wizard');
				} else {
					Ext.getCmp('mainView').getLayout().setActiveItem('discoveryView');
				}
			},
			failure: function(result, request) {
				Ext.MessageBox.show({
					title: l["Connection Error"],
					msg: result.responseText,
					icon: Ext.MessageBox.ERROR,
					closable: true
				});
			}
		});
	},

	onButtonAfterRender: function(component, eOpts) {
		component.setText(l["Start setup"]);
	},

	onAdminData1AfterRender: function(component, eOpts) {
		component.setTitle(l["Set password and email"]);
	}

});