function discovered_hosts_updater() {

	this.already_on_screen = new Array();
	this.source_object = null;
	this.callback = null;
	this.counter = 0;
	this.radix = null;

	this.set_callback = function(obj, callback) {
		this.source_object = obj;
		this.callback = callback;
	}

	this.fetch = function() {
		var post_data = {
			url: '/opmon/seagull/www/index.php/discovery/action/discovered_objects',
			already_on_screen: this.already_on_screen
		};

		do_request(post_data, this, "fetched");
	}

	this.fetched = function(msg) {

		var hosts;
		var host;
		var i;

		hosts = json_decode(msg);
		if (!hosts) {
			_err("unable to parse discovered hosts json");
			return;
		}

		for(i=0; i<hosts.length; i++) {

			host = hosts[i];
			this.insert_host_to_radix(host);

			if (this.already_on_screen.indexOf(host.discovery_id) < 0)
				this.already_on_screen.push(host.discovery_id);
		}

		if (hosts.length)
			this.source_object[this.callback](hosts);

	}

	this.insert_host_to_radix = function(host) {

		var idx;

		if (!this.radix)
			this.radix = new RadixTree();

		this.insert_key_value_radix(host.host_name, host.discovery_id);

		if (host.os)
			this.insert_key_value_radix(host.os, host.discovery_id);

		if (host.type == DISCOVERY_TYPE_WINDOWS) {
			this.insert_key_value_radix("Windows", host.discovery_id);
			this.insert_key_value_radix("windows", host.discovery_id);
		} else if (host.type == DISCOVERY_TYPE_LINUX) {
			this.insert_key_value_radix("Linux", host.discovery_id);
			this.insert_key_value_radix("linux", host.discovery_id);
		} else if (host.type == DISCOVERY_TYPE_ROUTER) {
			this.insert_key_value_radix("Router", host.discovery_id);
			this.insert_key_value_radix("router", host.discovery_id);
		} else {
			this.insert_key_value_radix("Unknown", host.discovery_id);
			this.insert_key_value_radix("unknown", host.discovery_id);
		}

		for(idx=0; idx<host.processes.length; idx++) {
			this.insert_key_value_radix(host.processes[idx], host.discovery_id);
		}

		for(idx=0; idx<host.open_ports.length; idx++) {
			this.insert_key_value_radix(host.open_ports[idx], host.discovery_id);
		}
	}

	this.insert_key_value_radix = function(key, value) {
		try {
			this.radix.insert(key, new Array(value));
		} catch(e) {
			var node;
			node = this.radix.find(key);
			node.push(value);
		}
	}

	this.remove_discovered_hosts = function(hosts) {

		var i;
		var host;
		var post_data = {
			url: '/opmon/seagull/www/index.php/discovery/action/discovery_jobs',
			operation: "delete_objects",
			ids_to_delete: new Array()
		};

		for(i=0; i<hosts.length; i++) {
			host = hosts[i];
			post_data.ids_to_delete.push(host.discovery_id);
		}

		do_request(post_data, this, "removed_discovered_hosts");

	}

	this.removed_discovered_hosts = function(msg) {
		this.source_object[this.callback](json_decode(msg));
	}

}
