/**
 * globals
 */
var uniq_ids = new Array();
var DISCOVERY_TYPE_WINDOWS = 0;
var DISCOVERY_TYPE_LINUX   = 1;
var DISCOVERY_TYPE_ROUTER  = 2;
var DISCOVERY_TYPE_OTHER   = 3;

function load_page(vars) {

	vars.is_interface = 1;
	vars.div_id = create_uniq_id();

	/*
	 * makes ajax request sending
	 * all vars as post variables
	 */
	jQuery.ajax({
		type: 'POST',
		url: "/opmon/seagull/www/index.php/discovery/",
		data: vars 

	}).done( function(msg) {

		var page_body = $("body");
		page_body.append("<div id='"+vars.div_id+"'>"+msg+"</div>");
		var div = $("#"+vars.div_id);

		div.kendoWindow({
			vars: vars,
			draggable: vars.hasOwnProperty("draggable")? vars.resizable : false,
			modal: vars.hasOwnProperty("modal")? vars.resizable : true,
			resizable: vars.hasOwnProperty("resizable")? vars.resizable : false,
			width: vars.width ? vars.width: "95%",
			height: vars.height ? vars.height : "85%",
			title: vars.title ? vars.title : "undefined",
			actions: get_window_buttons(vars),
			close: function(e) {
				$('#'+vars.div_id).html("");
				if (!run_callback(vars.div_id, "on_close"))
					e.preventDefault();
				else
					remove_uniq_id(vars.div_id);
			},
			refresh: function(e) {
				run_callback(vars.div_id, "on_refresh");
			},
			open: function(e) {
				run_callback(vars.div_id, "on_open");
			}
		});

		if (!vars.width && !vars.height)
			div.data("kendoWindow").maximize();

		if (vars.hasOwnProperty("center") && vars.center)
			div.data("kendoWindow").center();

	});
}

function run_callback(id, prop) {

	var w = $("#"+id);
	var inner_vars = w.data("kendoWindow").options.vars;
	var function_name = inner_vars[prop];

	if (!function_name)
		return true;

	if (typeof function_name == "boolean")
		return function_name;

	if (typeof window[function_name] != "function") {
		console.log("invalid callback: " + function_name);
		return true;
	}

	if (typeof window[function_name] == undefined)
		return true;

	try {
		return window[function_name](w);
	} catch(err) {
		console.log(err);
		return false;
	}

}

function get_window_buttons(props) {
	var window_buttons = new Array();
	if (props.hasOwnProperty("on_refresh"))
		window_buttons.push("Refresh");

	if (props.hasOwnProperty("on_close"))
		window_buttons.push("Close");

	return window_buttons;
}

function remove_uniq_id(id) {
	var index = uniq_ids.indexOf(id);
	if (index == -1)
		return;

	uniq_ids.splice(index, 1);
}

function create_uniq_id() {

	var id = Math.random().toString(36).substring(8);

	while(uniq_ids.indexOf(id) != -1)
		id = Math.random().toString(36).substring(8);
	
	uniq_ids.push(id);

	return id;
}

function do_request(post_data, obj, callback) {

	if (!post_data.url) {
		_err("invalid url");
		obj[callback](null);
		return;
	}

	jQuery.ajax({
		type: 'POST',
		url: post_data.url,
		data: post_data
	}).done(function(msg) {
		if (!obj[callback]) {
			_err("do_request: invalid callback: "+callback);
			return;
		}
		obj[callback](msg);
	}).error(function(jxhr, err_str, exception) {
		_err(err_str);
		if (!obj[callback]) {
			_err("do_request: invalid callback: "+callback);
			return;
		}
		obj[callback](err_str);
	});
}

function _err(str) {

	var error_msg;
	var callee;

	callee = arguments.callee.caller.name;
	if (!callee)
		callee = "anonymous"

	error_msg = callee +" says: "+str;
	console.log(error_msg);
}

function json_encode(obj) {
	return JSON.stringify(obj);
}

function json_decode(str) {
	var obj;

	try {
		obj = eval('('+str+')');
	} catch(e) {
		obj = null;
		_err(e.message);
	}

	return obj;
}

