function edit_hosts_general() {

	this.parsed_context = null;
	this.hostgroups = null;
	this.hostgroups_data_source = null;
	this.time_periods = null;
	this.time_periods_data_source = null;
	this.hosts = null;

	this.run = function(context) {

		this.parsed_context = json_decode(context);
		this.time_periods = this.parsed_context.time_periods;
		this.hostgroups = this.parsed_context.hostgroups;

		this.hosts_being_edited_observable = new kendo.observable({
			data: this.parsed_context.hosts_being_edited
		});

		this.prewarm_interface();
		this.assign_event_listeners();
		this.calcule_total_hosts();

	}

	this.prewarm_interface = function() {

		var i;
		var aux;

		this.time_periods_data_source = new kendo.data.DataSource({
			data: this.time_periods	
		});

		this.hostgroups_data_source = new kendo.data.DataSource({
			data: this.hostgroups
		});

		for(i=1; i<=100; i++) {
			aux = "<option value='"+i+"'>"+i+"</option>";
			jQuery("#host-checkinterval-select-all").append(aux);
		}

		kendo.bind(jQuery("#host-list-area"), this.hosts_being_edited_observable.data);

		jQuery(".host-checkinterval-combobox").kendoComboBox();

		jQuery(".host-timeperiod-combobox").kendoComboBox({
			dataSource: edit_hosts_general.time_periods_data_source,
			dataTextField: "timeperiod_name",
			dataValueField: "timeperiod_id"
		});

		jQuery(".host-groups-select").kendoMultiSelect({
			dataSource: edit_hosts_general.hostgroups_data_source,
			dataTextField: "hostgroup_name",
			dataValueField: "hostgroup_id"
		});

	}

	this.calcule_total_hosts = function() {
		var host_count = 0;
		jQuery(".host-line").each(function(){
			var self = jQuery(this);
			self.attr("id","host-line-" + host_count);
			if (host_count % 2 === 0 && host_count != 0) {
				self.addClass("k-alt");
			}
			host_count += 1;
		});
	}

	this.apply_check_interval_to_all_hosts = function() {
	}

	this.apply_time_period_to_all_hosts = function() {
	}

	this.assign_event_listeners = function() {

		jQuery("#host-timeperiod-select-all").kendoComboBox({
			dataSource: this.time_periods_data_source,
			dataTextField: "timeperiod_name",
			dataValueField: "timeperiod_id",
			change: edit_hosts_general.apply_time_period_to_all_hosts
		});

		jQuery("#host-checkinterval-select-all").kendoComboBox({
			change: edit_hosts_general.apply_check_interval_to_all_hosts
		});
		jQuery("#host-groups-select-all").kendoMultiSelect({
			dataSource: this.hostgroups_data_source,
			dataTextField: "hostgroup_name",
			dataValueField: "hostgroup_id",
			change: edit_hosts_general.apply_groups_to_all_hosts
		});
	}


	this.edit_services = function() {

		var i;
		var host;
		var window_properties = {
			title: "Editing services",
			template: "edit_services_general",
			hosts_being_edited: json_encode(edit_hosts_general.hosts_being_edited_observable.data),
			width: 900,
			height: 500,
			center: true,
			on_close: true,
			host_buckets_populated: true
		};

		load_page(window_properties);
	}

	this.apply_groups_to_all_hosts = function() {

		jQuery(this._dataItems).each(function(){

			var i;
			var selected_group;
			var host;

			selected_group = this.hostgroup_id;
			for(i=0; i<edit_hosts_general.hosts_being_edited_observable.data.length; i++) {
				host = edit_hosts_general.hosts_being_edited_observable.data[i];

				if (host.hostgroups.indexOf(selected_group) == -1) {
					host.hostgroups.push(selected_group);
				}

			}

		});

	}


}
