/*
 * File: app/controller/EditHostsController.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.controller.EditHostsController', {
	extend: 'Ext.app.Controller',

	viewsValidateData: {
		step01: {
			view: 'step01',
			btn: 'nextBtn02',
			requires: [
				'address',
				'host_name'
			]
		},
		step01b: {
			view: 'step01b',
			btn: 'nextBtn18',
			requires: [
				'max_check_attempts',
				'retry_interval',
				'address',
				'host_name',
				'check_interval',
				'notification_interval'
			]
		},
		step02: {
			view: 'step02',
			btn: 'nextBtn04',
			requires: [
				'max_check_attempts',
				'retry_check_interval',
				'normal_check_interval',
				'notification_interval',
				'service_description'
			]
		},
		editServices: {
			view: 'editServices',
			btn: 'nextBtn14',
			requires: [
				'notification_interval',
				'service_description',
				'normal_check_interval',
				'retry_check_interval',
				'max_check_attempts'
			]
		}
	},
	tooltipErrorOptions: {
		anchor: 'top',
		anchorToTarget: false,
		hideDelay: 15000,
		closable: false
	},
	msgErrors: {
		defaultError: l[
			'This field is mandatory'
		],
		check_interval: l[
			'Min'
		]+'. 1',
		notification_interval: l[
			'Min'
		]+'. 0',
		normal_check_interval: l[
			'Min'
		]+'. 1',
		max_check_attempts: l[
			'Min'
		]+'. 1',
		retry_check_interval: l[
			'Min'
		]+'. 1'
	},
	models: [
		'Contact',
		'TimePeriod',
		'Host',
		'HostGroup'
	],
	stores: [
		'contactStore',
		'hostGroupStore',
		'hostStore',
		'timePeriodStore',
		'serviceGroupStore',
		'hostDiscoveryStore'
	],

	refs: [
		{
			ref: 'serviceGrid',
			selector: '#sgrid'
		}
	],

	init: function(application) {
		var url;


		if (parent.WIZZARD_CONFIG_PARAMS === undefined ||
			parent.WIZZARD_CONFIG_PARAMS === null) {

			showError(l["Error"],l["Invalid request"]);
			return;
		}

		this.viewsValidateData.step01b.validator = this.validateInterval;
		this.viewsValidateData.step02.validator = this.validateInterval;
		this.viewsValidateData.editServices.validator = this.validateInterval;

		Wizard.urlData = parent.WIZZARD_CONFIG_PARAMS;
	},

	addHost: function(hostname) {
		if (this.hostNames === undefined) {
			this.hostNames = [];
		}

		this.hostNames.push(hostname);
	},

	addHostBuckets: function(buckets, doNotCreateUniq) {
		var hostStore;
		var i;
		var serviceKnown = {};
		var j;
		var service;
		var host;
		var pos;
		var aux;

		this.hostBuckets = buckets;

		hostStore = this.application.getHostStoreStore();
		hostStore.removeAll();
		hostStore.add(buckets);

		if (doNotCreateUniq === undefined) {
			createServicesUniqList();
		}
	},

	getEditableServices: function() {
		me = Wizard.getApplication().getEditHostsControllerController();

		/* show progress bar */
		makeActiveView("editServicesLoadingScreen");
		Ext.getCmp("loadingServicesProgressBar").wait({
			text: l.ObjectsLoadingMsg
		});

		Ext.Ajax.request({
			url: '/opmon/seagull/www/index.php/discovery/action/servicebuckets/',
			method: 'POST',
			params: {
				services_being_edited: JSON.stringify(Wizard.urlData.services)
			},
			success: function(result, request) {
				var wsreturn;

				try {
					wsreturn = JSON.parse(result.responseText);
				} catch(err) {
					showError(l["Unexpected error"], err.message);
					return;
				}
				/**
				* some services do not belong to host,
				* they belong to a template or hostgroup
				* and thus cannot be edited, we just show
				* them on a window
				**/
				if (wsreturn.services_on_template.length > 0) {
					showTemplatesWindow(wsreturn);
				}

				var groupedServices = me.preProcessServices(wsreturn.services);

				makeActiveView("editServices");
				Ext.getCmp("editServices").allServicesBeingEdited = wsreturn.services;
				Ext.getCmp("editServices").groupedServices = groupedServices;

			},
			failure: function(result, request) {
				var wsreturn;

				try {
					wsreturn = JSON.parse(result.responseText);
				} catch(err) {
					showError(l["Unexpected error"], err.message);
					return;
				}

				if (!wsreturn.message) {
					showError(l["Connection	error"], result.responseText, result);
					return;
				}

				showError(l["Unexpected error"], wsreturn.message);
			}

		});


		/**
		* shows a grid with all services
		* that belong to a template or
		* a hostgroup
		*/
		showTemplatesWindow = function(obj) {

			var myWindow = Ext.create('Ext.window.Window', {
				id: 'recordWindow',
				title: l[obj.message],
				resizable: false,
				closable: true,
				draggable: true,
				width: 600,
				height: 300,
				maxWidth: 600,
				maxHeight: 300,
				layout: 'fit',
				plain:true,
				buttons: [
					{
						text: 'OK',
						handler: function(){
							Ext.getCmp("recordWindow").close();
						}
					}
				],
				listeners: {
					close: function() {
						if (obj.success || !Wizard.endCallBack)
							return;

						func = "parent."+Wizard.endCallBack+"(false);";
						eval(func);
					}
				}
			});

			var store = Ext.create('Ext.data.ArrayStore', {
				storeId: 'myStore',
				fields: [ "service_id", "host_name", "service_description", "template_name", "hostgroup_name" ]
			});
			store.add(obj.services_on_template);

			var grid = Ext.create('Ext.grid.Panel', {
				store: store,
				stateful: true,
				stateId: 'stateGrid',
				multiSelect : true,
				selModel: {
					mode: "MULTI"
				},
				columns: [
					{
						text     : l.Host,
						flex     : 1,
						sortable : true,
						dataIndex: 'host_name',
						editor: 'textfield'
					},
					{
						text     : l.Service,
						flex     : 1,
						sortable : true,
						dataIndex: 'service_description',
						editor: 'textfield'
					},
					{
						text     : l["Template name"],
						flex     : 1,
						sortable : true,
						dataIndex: 'template_name',
						editor: 'textfield'
					},
					{
						text     : l.Hostgroup,
						flex     : 1,
						sortable : true,
						dataIndex: 'hostgroup_name',
						editor: 'textfield'
					},
					{
						xtype: 'actioncolumn',
						width: 35,
						items: [
							{
								icon: '/opmon/seagull/modules/statusgrid/templates/imgs/ico-editar.png',
								tooltip: l['Edit service'],
								handler: function(grid, rowIndex, colIndex) {
									var s = grid.getStore().getAt(rowIndex);
									var url = "/opmon/seagull/www/index.php/opinterface/action/index/?initial_page=/opmon/opcfg/?formTo=SERVICE_ID:"+s.data.service_id;
									window.open(url,'_blank');
								}
							}
						]
					}
				],
				listeners: {
					viewready: function(grid) {
						var map = new Ext.KeyMap(grid.getEl(), [{
							key: "c",
							ctrl: true,
							fn: function(keyCode, e) {
								var recs = grid.getSelectionModel().getSelection();

								if (recs && recs.length === 0)
									return;

								var cliptext = "";
								for(var i=0; i<recs.length; i++){
									var svc = recs[i].data;
									cliptext += svc.host_name+","+svc.service_description+",";
									cliptext += svc.template_name+","+svc.hostgroup_name+"\n";
								}

								var ta = document.createElement('textarea');
								ta.id = 'cliparea';
								ta.style.position = 'absolute';
								ta.style.left = '-1000px';
								ta.style.top = '-1000px';
								ta.value = cliptext;
								document.body.appendChild(ta);
								document.designMode = 'off';

								ta.focus();
								ta.select();

								setTimeout(function(){
									document.body.removeChild(ta);
								}, 100);

							}

						}]);
					}
				}
			});

			myWindow.add(grid);
			myWindow.show();

		};

	},

	preProcessServices: function(services) {
		/**
		* group services by check command and
		* service description
		**/
		var groupedServices = {};

		serviceStore = Wizard.getApplication().getServiceStoreStore();

		Ext.each(services, function(svc) {

			var svckey = svc.original_check_command+"-"+svc.original_service_description;

			svc.key_id = svckey;

			/**
			* service with different check command
			* and service description, we just add it
			**/
			if (groupedServices[svckey] === undefined) {
				serviceStore.add(svc);

				groupedServices[svckey] = {
					ref: serviceStore.getAt(serviceStore.getCount()-1),
					services: [svc]
				};

				return;
			}

			/* increment counter and push to services array */
			var count = groupedServices[svckey].ref.get("count");
			count++;
			groupedServices[svckey].ref.set("count",count);
			groupedServices[svckey].services.push(svc);

		});

		serviceStore.sort();
		return groupedServices;
	},

	validateStore: function(store, view, callback) {
		var viewId = view || Ext.getCmp('WizardMainViewPort').getLayout().activeItem.el.id;
		var me = this;

		if(this.viewsValidateData[viewId]) {
			var obj = this.viewsValidateData[viewId]
			Opmon_validateStore(obj, store, function(err, result) {
				me.enableNext(! err, viewId);
				runCallback(err, result);
			});
		} else {
			runCallback(false);
		}

		function runCallback() {
			if(callback) {
				callback.apply(window, arguments);
			}
		}
	},

	enableNext: function(enable, view) {
		var method = enable ? 'enable' : 'disable';
		Ext.getCmp(this.viewsValidateData[view].btn)[method]();
	},

	validateInterval: function(curr, key) {
		var validator = { "retry_check_interval": 1, "retry_interval": 1, "max_check_attempts": 1, "normal_check_interval": 1, "check_interval": 1, "notification_interval": 0 };
		var hasProperty = validator.hasOwnProperty(key);

		return (hasProperty && Number(curr[key]) >= Number(validator[key]))
					|| (! hasProperty && curr[key] !== "");
	},

	createTooltipErrorHandler: function(cmp, msg, destroy) {
		if(! destroy && ! cmp.hasTooltip) {
			var target = cmp.getXY();
			var tooltipOptions = this.tooltipErrorOptions;

			tooltipOptions.targetXY = [target[0]+15, target[1]];
			tooltipOptions.html = msg;

			cmp.errorTooltipHandler = new Ext.ToolTip(tooltipOptions);
			cmp.on('mouseover', showTooltip(cmp));
			cmp.hasTooltip = true;
			cmp.errorTooltipHandler.show();

		} else if(destroy) {
			delete cmp.errorTooltipHandler;
			cmp.hasTooltip = false;
		}


		function showTooltip(cmp) {
			return function() {
				if(cmp.hasTooltip) {
					cmp.errorTooltipHandler.show();
				}
			}
		}
	},

	onEditCellGrid: function(store, e, view) {
		var me = this;

		store.on('update', function storeUpdateCallback() {
			me.validateStore(store, view, function(err, result) {
				var dataIndex = e.grid.getView().getHeaderCt().columnManager.columns[e.colIdx].dataIndex;
				var validate = err
					&& result.indexs.some(function(index) {return e.rowIdx === index})
					&& result.keys.some(function(key) {return key === dataIndex});
				var borderColor = validate ? "#cf4c35" : "";
				var columnCmp = Ext.get(e.row.childNodes[e.colIdx]);
				var msg = me.msgErrors.hasOwnProperty(dataIndex) ? me.msgErrors[dataIndex] : me.msgErrors["defaultError"];;
				var column = e.row.childNodes[e.colIdx];

				if(column && columnCmp) {
					e.row.childNodes[e.colIdx].style.borderColor = borderColor;
					me.createTooltipErrorHandler(columnCmp, msg, ! validate);
				}
			});
			this.un('update', storeUpdateCallback); // remove this update to not queue events
		});
	}

});
