/*
 * File: app/model/Host.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.model.Host', {
	extend: 'Ext.data.Model',

	requires: [
		'Ext.data.Field'
	],

	idProperty: 'host_id',

	fields: [
		{
			name: 'host_id'
		},
		{
			name: 'host_name'
		},
		{
			name: 'alias'
		},
		{
			name: 'address'
		},
		{
			name: 'check_command'
		},
		{
			name: 'max_check_attempts'
		},
		{
			name: 'check_interval'
		},
		{
			name: 'passive_checks_enabled'
		},
		{
			name: 'check_period'
		},
		{
			name: 'obsess_over_host'
		},
		{
			name: 'check_freshness'
		},
		{
			name: 'freshness_threshold'
		},
		{
			name: 'active_checks_enabled'
		},
		{
			name: 'checks_enabled'
		},
		{
			name: 'event_handler'
		},
		{
			name: 'event_handler_enabled'
		},
		{
			name: 'low_flap_threshold'
		},
		{
			name: 'high_flap_threshold'
		},
		{
			name: 'flap_detection_enabled'
		},
		{
			name: 'extended_info'
		},
		{
			convert: function(v, rec) {
				return rec.get("extended_info").icon_image;
			},
			mapping: 'extended_info.icon_image',
			name: 'icon_image'
		},
		{
			name: 'process_perf_data'
		},
		{
			name: 'retain_status_information'
		},
		{
			name: 'retain_nonstatus_information'
		},
		{
			name: 'notification_interval'
		},
		{
			name: 'notification_period'
		},
		{
			convert: function(v, rec) {
				return ((v == 1) || (v === true));
			},
			name: 'notifications_enabled'
		},
		{
			name: 'notification_options_down'
		},
		{
			name: 'notification_options_unreachable'
		},
		{
			name: 'notification_options_recovery'
		},
		{
			name: 'notification_options_flapping'
		},
		{
			name: 'stalking_options_up'
		},
		{
			name: 'stalking_options_down'
		},
		{
			name: 'stalking_options_unreachable'
		},
		{
			name: 'failure_prediction_enabled'
		},
		{
			name: 'retry_interval'
		},
		{
			name: 'snmp_timeout'
		},
		{
			name: 'snmp_retries'
		},
		{
			name: 'snmp_port'
		},
		{
			name: 'community_id'
		},
		{
			name: 'notification_options_downtime'
		},
		{
			name: 'hostgroups'
		},
		{
			name: 'services'
		},
		{
			name: 'templates'
		},
		{
			name: 'selected'
		},
		{
			name: 'already_monitored'
		},
		{
			name: 'contacts'
		},
		{
			name: 'contactgroups'
		},
		{
			name: 'hash'
		},
		{
			name: 'check_parameters'
		},
		{
			name: 'original_host_name'
		},
		{
			convert: function(v, rec) {
				return rec.get("extended_info").notes_url;
			},
			name: 'notes_url'
		},
		{
			name: 'is_scat',
			type: 'boolean'
		},
		{
			convert: function(v, rec) {
				return rec.get("extended_info").action_url;
			},
			name: 'action_url'
		}
	],

	hasService: function(serviceDescription) {
		var services;
		var i;
		var service;

		services = this.get("services");
		for(i=0; i<services.length; i++) {
			service = services[i];
			if (services.service_description == serviceDescription) {
				return true;
			}
		}

		return false;
	},

	addService: function(service) {
		if (this.hasService(service.service_description)) {
			return;
		}

		var services;

		services = this.get("services");
		services.push(service);
	},

	addHostGroup: function(hostgroup) {
		hostgroups = this.get("hostgroups");
		if (hostgroups.indexOf(hostgroup) >= 0 ) {
			return;
		}

		hostgroups.push(hostgroup);
	},

	removeHostGroup: function(hostgroup) {
		hostgroups = this.get("hostgroups");
		idx = hostgroups.indexOf(hostgroup);
		if (idx < 0) {
			return;
		}

		hostgroups.splice(idx,1);
	}

});