/*
 * File: app/view/createCommand.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.view.createCommand', {
	extend: 'Ext.window.Window',

	requires: [
		'Ext.form.Panel',
		'Ext.form.field.TextArea',
		'Ext.form.field.File',
		'Ext.toolbar.Toolbar',
		'Ext.button.Button',
		'Ext.toolbar.Spacer'
	],

	draggable: false,
	height: 315,
	id: 'createCommandWindow',
	width: 600,
	title: 'Defina os parâmetros do comando',
	modal: true,

	layout: {
		type: 'vbox',
		align: 'stretch'
	},

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'container',
					id: 'createCommandContainer',
					layout: {
						type: 'vbox',
						align: 'stretch'
					},
					items: [
						{
							xtype: 'form',
							flex: 2,
							id: 'defineParamsPanel',
							margin: '0 3 0 0',
							minWidth: 590,
							width: 600,
							bodyPadding: 20,
							header: false,
							title: 'Defina os parâmetros do comando',
							layout: {
								type: 'vbox',
								align: 'stretch'
							},
							items: [
								{
									xtype: 'textfield',
									flex: 1,
									id: 'newCommandCommandName',
									fieldLabel: 'Nome',
									labelSeparator: ' ',
									labelWidth: 60,
									enableKeyEvents: true,
									listeners: {
										blur: {
											fn: me.onNewCommandCommandNameBlur,
											scope: me
										},
										beforerender: {
											fn: me.onNewCommandCommandNameBeforeRender,
											scope: me
										}
									}
								},
								{
									xtype: 'textareafield',
									flex: 1,
									id: 'newCommandCommandDesc',
									minHeight: 40,
									fieldLabel: 'Descrição',
									labelSeparator: ' ',
									labelWidth: 60,
									rows: 3,
									listeners: {
										beforerender: {
											fn: me.onNewCommandCommandDescBeforeRender,
											scope: me
										}
									}
								},
								{
									xtype: 'filefield',
									flex: 1,
									id: 'newCommandCommandPlugin',
									fieldLabel: 'Plugin',
									labelSeparator: ' ',
									labelWidth: 60,
									listeners: {
										change: {
											fn: me.onNewCommandCommandPluginChange,
											scope: me
										}
									}
								},
								{
									xtype: 'textareafield',
									flex: 1,
									id: 'newCommandCommandLine',
									minHeight: 40,
									fieldLabel: 'Linha de Comando',
									labelSeparator: ' ',
									labelWidth: 60,
									value: '/usr/local/opmon/libexec/custom',
									listeners: {
										beforerender: {
											fn: me.onNewCommandCommandLineBeforeRender,
											scope: me
										}
									}
								}
							]
						}
					]
				}
			],
			dockedItems: [
				{
					xtype: 'toolbar',
					dock: 'bottom',
					baseCls: 'x-toolbar-footer',
					id: 'navBar7',
					items: [
						{
							xtype: 'button',
							handler: function(button, event) {
								Ext.getCmp("createCommandWindow").close();
							},
							id: 'prevBtn11',
							text: 'Cancelar',
							listeners: {
								beforerender: {
									fn: me.onPrevBtn11BeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'tbspacer',
							flex: 1
						},
						{
							xtype: 'container',
							items: [
								{
									xtype: 'button',
									handler: function(button, event) {

										var cmd_name = Ext.getCmp("newCommandCommandName").getValue();
										var cmd_desc = Ext.getCmp("newCommandCommandDesc").getValue();
										var cmd_line = Ext.getCmp("newCommandCommandLine").getValue();
										var error_msg = null;


										if ((cmd_desc === null) || (cmd_desc === "")) {
											error_msg = "Invalid command description.";
										}

										if ((cmd_line === null) || (cmd_line === "")) {
											error_msg = "Invalid command line.";
										}

										if ((cmd_name === null) || (cmd_name.length < 2)) {
											error_msg = "Command name must have at last 2 caracters.";
										}

										if (error_msg !== null) {
											Ext.Msg.show({
												title: 'Error',
												msg: l[error_msg],
												width: 420,
												buttons: Ext.Msg.OK,
												icon: Ext.MessageBox.ERROR
											});
											return false;
										}

										var after = {
											success: function(result, request) {
												var cmd;
												var commandStore;

												cmd = {
													network_id: 0,
													command_name: Ext.getCmp("newCommandCommandName").getValue(),
													command_desc: Ext.getCmp("newCommandCommandDesc").getValue(),
													command_line: Ext.getCmp("newCommandCommandLine").getValue(),
													system: 0
												}

												commandStore = Wizard.getApplication().getCommandStoreStore();
												commandStore.add(cmd);
												commandStore.sync({
													success: function(a) {
														showInfo("Information", "Command saved successfuly");
														Ext.getCmp("createCommandWindow").close();
													},
													failure: function(b) {
														showError(l["Error"], l["Connection Error"]);
													}
												});

											},
											failure: function(f, a) {
												showError(l["Error"], l["Connection Error"]);
											}
										}

										if (Ext.getCmp("newCommandCommandPlugin").getValue() == "") {
											after.success({success: true}, null);
											return;
										}

										var form = new Ext.FormPanel({
											url: '/opmon/seagull/www/index.php/discovery/action/uploadplugin/',
											isUpload: true,
											method: 'POST'
										});

										form.add(Ext.getCmp("newCommandCommandPlugin"));
										form.submit(after);
									},
									id: 'nextBtn7',
									text: 'Salvar comando criado',
									listeners: {
										beforerender: {
											fn: me.onNextBtn7BeforeRender,
											scope: me
										}
									}
								}
							]
						}
					]
				}
			],
			listeners: {
				beforerender: {
					fn: me.onCreateCommandWindowBeforeRender,
					scope: me
				}
			}
		});

		me.callParent(arguments);
	},

	onNewCommandCommandNameBlur: function(component, e, eOpts) {
		component.setValue(
			changeCharCode(component.getValue())
		);
	},

	onNewCommandCommandNameBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Name"];
	},

	onNewCommandCommandDescBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Description"];
	},

	onNewCommandCommandPluginChange: function(filefield, value, eOpts) {
		var arr;

		arr = value.split("\\");
		Ext.getCmp("newCommandCommandLine").setValue(Ext.getCmp("newCommandCommandLine").getValue() +"/"+ arr[arr.length - 1]);
	},

	onNewCommandCommandLineBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Command Line"];
	},

	onPrevBtn11BeforeRender: function(component, eOpts) {
		component.text = l["Cancel"];
	},

	onNextBtn7BeforeRender: function(component, eOpts) {
		component.text = l["Save"];
	},

	onCreateCommandWindowBeforeRender: function(component, eOpts) {
		component.title = l["Set the parameters of the command"];
	}

});