/*
 * File: app/view/editContactsPanel.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.view.editContactsPanel', {
	extend: 'Ext.panel.Panel',
	alias: 'widget.editcontactspanel',

	requires: [
		'Ext.tree.Panel',
		'Ext.tree.View',
		'Ext.tree.plugin.TreeViewDragDrop',
		'Ext.form.Panel',
		'Ext.form.Label',
		'Ext.form.field.ComboBox',
		'Ext.button.Button',
		'Ext.form.field.TextArea',
		'Ext.form.field.Checkbox',
		'Ext.toolbar.Toolbar',
		'Ext.toolbar.Spacer'
	],

	height: 500,
	id: 'editContactsPanel',
	width: 800,
	header: false,
	title: 'Editar Grupos de Hosts',

	layout: {
		type: 'vbox',
		align: 'stretch'
	},

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'container',
					flex: 1,
					id: 'treesContainers1',
					layout: {
						type: 'hbox',
						align: 'stretch'
					},
					items: [
						{
							xtype: 'panel',
							flex: 1,
							id: 'teamPanel',
							padding: '0 2 0 0',
							bodyPadding: 5,
							title: 'Equipes Responsáveis',
							layout: {
								type: 'hbox',
								align: 'stretch'
							},
							items: [
								{
									xtype: 'container',
									flex: 1,
									layout: {
										type: 'hbox',
										align: 'stretch'
									},
									items: [
										{
											xtype: 'treepanel',
											flex: 1,
											autoRender: true,
											id: 'teamsTreePanel',
											maxWidth: 180,
											minWidth: 180,
											header: false,
											title: 'My Tree Panel',
											hideHeaders: true,
											store: 'contactGroupTreeStore',
											displayField: 'contactgroup_name',
											rootVisible: false,
											viewConfig: {
												id: 'teamsTreeview',
												plugins: [
													Ext.create('Ext.tree.plugin.TreeViewDragDrop', {
														allowParentInserts: true,
														appendOnly: true
													})
												],
												listeners: {
													itemclick: {
														fn: me.onHostGroupsTreeviewItemClick,
														scope: me
													}
												}
											},
											listeners: {
												beforeitemmove: {
													fn: me.onHostGroupsTreePanelBeforeItemMove,
													scope: me
												}
											}
										},
										{
											xtype: 'panel',
											flex: 5,
											activeItem: 1,
											id: 'editTeamPanel',
											layout: 'card',
											header: false,
											title: 'My Panel',
											items: [
												{
													xtype: 'panel',
													id: 'optionsTeamPanel',
													bodyPadding: '20 10 0',
													header: false,
													title: 'My Panel',
													layout: {
														type: 'vbox',
														align: 'stretch'
													},
													items: [
														{
															xtype: 'form',
															flex: 1,
															id: 'addUserToTeam',
															bodyPadding: 10,
															header: false,
															title: 'My Form',
															items: [
																{
																	xtype: 'label',
																	text: 'Adicionar usuários a equipe'
																},
																{
																	xtype: 'combobox',
																	anchor: '100%',
																	id: 'addUserTeamTeam',
																	fieldLabel: 'Label',
																	hideLabel: true,
																	emptyText: 'Selecione o grupo',
																	displayField: 'contactgroup_name',
																	store: 'contactGroupStore',
																	valueField: 'contactgroup_id'
																},
																{
																	xtype: 'combobox',
																	anchor: '100%',
																	id: 'addUserTeamUser',
																	fieldLabel: 'Label',
																	hideLabel: true,
																	emptyText: 'Selecione os hosts',
																	displayField: 'contact_name',
																	multiSelect: true,
																	queryCaching: false,
																	queryMode: 'local',
																	store: 'contactStore',
																	valueField: 'contact_id'
																},
																{
																	xtype: 'button',
																	id: 'applyHostGroup1',
																	text: 'Aplicar',
																	listeners: {
																		click: {
																			fn: me.onApplyContactGroupClick,
																			scope: me
																		}
																	}
																}
															]
														},
														{
															xtype: 'button',
															handler: function(button, event) {
																Ext.getCmp('editTeamPanel').getLayout().setActiveItem('newTeam');
															},
															id: 'newTeamBtn',
															margin: '0 0 10 0',
															glyph: 43,
															text: 'Nova equipe'
														}
													]
												},
												{
													xtype: 'form',
													id: 'newTeam',
													maxHeight: 250,
													bodyPadding: 10,
													header: false,
													title: 'My Form',
													layout: {
														type: 'vbox',
														align: 'stretch'
													},
													items: [
														{
															xtype: 'label',
															cls: 'bold',
															height: 30,
															text: 'Criar/Editar equipe',
															listeners: {
																beforerender: {
																	fn: me.onLabelBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'textfield',
															id: 'newTeamName',
															fieldLabel: 'Nome',
															labelSeparator: ' ',
															labelWidth: 60,
															enableKeyEvents: true,
															listeners: {
																blur: {
																	fn: me.onNewTeamNameBlur,
																	scope: me
																},
																beforerender: {
																	fn: me.onNewTeamNameBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'textareafield',
															id: 'newTeamAlias',
															fieldLabel: 'Descrição',
															labelSeparator: ' ',
															labelWidth: 60,
															listeners: {
																beforerender: {
																	fn: me.onNewTeamAliasBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'combobox',
															id: 'newTeamUsers',
															fieldLabel: 'Usuários',
															labelSeparator: ' ',
															labelWidth: 60,
															validateOnChange: false,
															autoSelect: false,
															displayField: 'contact_name',
															multiSelect: true,
															queryMode: 'local',
															store: 'contactStore',
															valueField: 'contact_id',
															listeners: {
																beforerender: {
																	fn: me.onNewTeamUsersBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'container',
															flex: 1,
															id: 'newGroupNav2',
															margin: '10 0 0',
															maxHeight: 26,
															layout: {
																type: 'hbox',
																align: 'stretch'
															},
															items: [
																{
																	xtype: 'container',
																	flex: 1,
																	id: 'spacer11'
																},
																{
																	xtype: 'button',
																	handler: function(button, event) {
																		var c;
																		var contactgroupStore;
																		var afterSync;
																		var exists;
																		var newContactGroupName;

																		newContactGroupName = Ext.getCmp('newTeamName').getValue();
																		if (newContactGroupName == "") {
																			showInfo( l["Information"], l["Invalid team name"]);
																			return;
																		}

																		contactgroupStore = Wizard.getApplication().getContactGroupStoreStore();
																		exists = contactgroupStore.find("contactgroup_name", newContactGroupName);
																		if (exists >= 0) {
																			showInfo( l["Information"], Ext.getCmp('newTeamName').getValue() + " "+l["Already exists"] );
																			return;
																		}

																		Ext.getCmp('teamsTreePanel').disable();

																		c = {
																			network_id: 0,
																			contactgroup_name: newContactGroupName,
																			alias: Ext.getCmp('newTeamAlias').getValue(),
																			members: []
																		};
																		contactgroupStore.add(c);

																		afterSync = {

																			success: function(batch, options) {

																				c = Ext.clone(getContactGroupByName(Ext.getCmp('newTeamName').getValue()));

																				contactsStore = Wizard.getApplication().getContactStoreStore();
																				treeStore = Ext.getCmp('teamsTreePanel').getStore();

																				selectedContacts = Ext.getCmp('newTeamUsers').getValue();
																				for(i=0; i<selectedContacts.length; i++) {

																					contact = getContactById(selectedContacts[i]);
																					if (!contact) {
																						continue;
																					}

																					c.appendChild({
																						contact_id: contact.get("contact_id"),
																						contact_name: contact.get("contact_name"),
																						contactgroup_id: getUniqId(),
																						contactgroup_name: contact.get("contact_name"),
																						leaf:true
																					});
																				}

																				treeStore.getRootNode().appendChild(c);

																				if (i === 0) {
																					Ext.getCmp('teamsTreePanel').enable();
																				} else {
																					addContactsToContactgroupOnServer(selectedContacts,c.get("contactgroup_id"));
																				}

																				store = Wizard.getApplication().getContactTreeStoreStore();
																				store.getRootNode().removeAll();
																				store.load();
																				Ext.getCmp('newTeamName').setValue("");
																				Ext.getCmp('newTeamAlias').setValue("");


																			},
																			failure: function(batch, options) {
																				showError( l["Storage error"], "Unable to sync contact groups", batch);
																			}
																		}

																		contactgroupStore.sync(afterSync);
																	},
																	flex: 1,
																	id: 'saveNewTeam',
																	text: 'Salvar',
																	listeners: {
																		beforerender: {
																			fn: me.onSaveNewTeamBeforeRender,
																			scope: me
																		}
																	}
																}
															]
														}
													]
												}
											]
										}
									]
								}
							],
							listeners: {
								beforerender: {
									fn: me.onTeamPanelBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'panel',
							flex: 1,
							id: 'userPanel',
							padding: '0 0 0 3',
							bodyPadding: 5,
							title: 'Usuários Responsáveis',
							layout: {
								type: 'hbox',
								align: 'stretch'
							},
							items: [
								{
									xtype: 'container',
									flex: 1,
									layout: {
										type: 'hbox',
										align: 'stretch'
									},
									items: [
										{
											xtype: 'treepanel',
											flex: 1,
											id: 'contactsTreePanel',
											maxWidth: 180,
											minWidth: 180,
											header: false,
											title: 'serviceGroupsTreePanel',
											hideHeaders: true,
											store: 'contactTreeStore',
											displayField: 'contact_name',
											rootVisible: false,
											viewConfig: {
												plugins: [
													Ext.create('Ext.tree.plugin.TreeViewDragDrop', {
														appendOnly: true
													})
												],
												listeners: {
													itemclick: {
														fn: me.onViewItemClick,
														scope: me
													}
												}
											},
											listeners: {
												beforeitemmove: {
													fn: me.onServiceGroupsTreePanelBeforeItemMove,
													scope: me
												}
											}
										},
										{
											xtype: 'panel',
											flex: 5,
											activeItem: 1,
											id: 'editUserPanel',
											layout: 'card',
											header: false,
											title: 'My Panel',
											items: [
												{
													xtype: 'panel',
													id: 'optionsUserPanel',
													bodyPadding: '20 10 0',
													header: false,
													title: 'My Panel',
													layout: {
														type: 'vbox',
														align: 'stretch'
													},
													items: [
														{
															xtype: 'form',
															flex: 1,
															id: 'addTeamToUser',
															padding: 10,
															header: false,
															title: 'My Form',
															items: [
																{
																	xtype: 'label',
																	text: 'Adicionar equipes a usuário'
																},
																{
																	xtype: 'combobox',
																	anchor: '100%',
																	id: 'addUserTeamsUser',
																	fieldLabel: 'Label',
																	hideLabel: true,
																	emptyText: 'Selecione o contato',
																	displayField: 'contact_name',
																	store: 'contactStore',
																	valueField: 'contact_id'
																},
																{
																	xtype: 'combobox',
																	anchor: '100%',
																	id: 'addUserTeamsTeams',
																	fieldLabel: 'Label',
																	hideLabel: true,
																	emptyText: 'Selecione os serviços',
																	displayField: 'contactgroup_name',
																	multiSelect: true,
																	store: 'contactGroupStore',
																	valueField: 'contactgroup_id'
																},
																{
																	xtype: 'button',
																	handler: function(button, event) {
																		Ext.getCmp('teamsTreePanel').disable();
																		Ext.getCmp('contactsTreePanel').disable();

																		contactId = Ext.getCmp("addUserTeamsUser").getValue();
																		contactGroupsIds = Ext.getCmp("addUserTeamsTeams").getValue();

																		Ext.Ajax.request({
																			url: '/opmon/seagull/www/index.php/discovery/action/contacts/operation/addcontactgroupstocontact/',
																			method: 'POST',
																			params: {
																				contact_id: contactId,
																				contactgroups: JSON.stringify(contactGroupsIds)
																			},

																			success: function(result,request) {

																				var obj;

																				obj = JSON.parse(result.responseText);
																				if (!obj) {
																					showError(
																					"Unexpected error",
																					"Unable to parse json"
																					);
																					return;
																				}

																				if (!obj.success) {
																					showError(
																					"Unexpected error",
																					obj.message
																					);
																					return;
																				}


																				store = Wizard.getApplication().getContactGroupTreeStoreStore();
																				store.getRootNode().removeAll();
																				store.load();
																				store = Wizard.getApplication().getContactTreeStoreStore();
																				store.getRootNode().removeAll();
																				store.load();
																				Ext.getCmp('teamsTreePanel').enable();
																				Ext.getCmp('contactsTreePanel').enable();

																			},
																			failure: function(result, request) {
																				showError(
																				"Unexpected error",
																				"Unable to reach server"
																				);
																			}


																		});

																	},
																	id: 'applyUser',
																	text: 'Aplicar'
																}
															]
														},
														{
															xtype: 'button',
															handler: function(button, event) {
																Ext.getCmp('editUserPanel').getLayout().setActiveItem('newUser');
															},
															id: 'newUserBtn',
															margin: '0 0 10 0',
															glyph: 43,
															text: 'Novo usuário'
														}
													]
												},
												{
													xtype: 'form',
													id: 'newUser',
													bodyPadding: 10,
													header: false,
													title: 'My Form',
													layout: {
														type: 'vbox',
														align: 'stretch'
													},
													items: [
														{
															xtype: 'label',
															cls: 'bold',
															height: 30,
															text: 'Criar/Editar grupo',
															listeners: {
																beforerender: {
																	fn: me.onLabelBeforeRender1,
																	scope: me
																}
															}
														},
														{
															xtype: 'textfield',
															id: 'newUserName',
															fieldLabel: 'Nome',
															labelSeparator: ' ',
															labelWidth: 60,
															enableKeyEvents: true,
															listeners: {
																blur: {
																	fn: me.onNewUserNameBlur,
																	scope: me
																},
																beforerender: {
																	fn: me.onNewUserNameBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'textareafield',
															id: 'newUserAlias',
															fieldLabel: 'Descrição',
															labelSeparator: ' ',
															labelWidth: 60,
															rows: 2,
															listeners: {
																beforerender: {
																	fn: me.onNewUserAliasBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'textfield',
															id: 'newUserMail',
															fieldLabel: 'E-mail',
															labelSeparator: ' ',
															labelWidth: 60
														},
														{
															xtype: 'textfield',
															id: 'newUserPhone',
															fieldLabel: 'Celular',
															labelSeparator: ' ',
															labelWidth: 60,
															listeners: {
																beforerender: {
																	fn: me.onNewUserPhoneBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'combobox',
															id: 'newUserType',
															fieldLabel: 'Tipo',
															labelSeparator: ' ',
															labelWidth: 60,
															value: 1,
															selectOnFocus: true,
															displayField: 'description',
															forceSelection: true,
															queryMode: 'local',
															store: 'contactTypeStore',
															valueField: 'value',
															listeners: {
																beforerender: {
																	fn: me.onNewUserTypeBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'combobox',
															id: 'newUserLang',
															fieldLabel: 'Língua',
															labelSeparator: ' ',
															labelWidth: 60,
															displayField: 'description',
															queryMode: 'local',
															store: 'languageStore',
															valueField: 'value',
															listeners: {
																beforerender: {
																	fn: me.onNewUserLangBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'combobox',
															id: 'newUserContactGroups',
															fieldLabel: 'Equipes',
															labelSeparator: ' ',
															labelWidth: 60,
															displayField: 'contactgroup_name',
															multiSelect: true,
															queryMode: 'local',
															store: 'contactGroupStore',
															valueField: 'contactgroup_id',
															listeners: {
																beforerender: {
																	fn: me.onNewUserContactGroupsBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'checkboxfield',
															id: 'newUserExternalAuth',
															fieldLabel: 'Label',
															hideLabel: true,
															boxLabel: 'Usar autenticação externa',
															listeners: {
																change: {
																	fn: me.onNewUserExternalAuthChange,
																	scope: me
																},
																beforerender: {
																	fn: me.onNewUserExternalAuthBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'textfield',
															id: 'newUserPass',
															fieldLabel: 'Senha',
															labelSeparator: ' ',
															labelWidth: 60,
															inputType: 'password',
															listeners: {
																beforerender: {
																	fn: me.onNewUserPassBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'textfield',
															id: 'newUserConfPass',
															fieldLabel: 'Confirmar senha',
															labelSeparator: ' ',
															labelWidth: 60,
															inputType: 'password',
															listeners: {
																beforerender: {
																	fn: me.onNewUserConfPassBeforeRender,
																	scope: me
																}
															}
														},
														{
															xtype: 'container',
															flex: 1,
															id: 'newGroupNav3',
															margin: '10 0 0',
															maxHeight: 26,
															layout: {
																type: 'hbox',
																align: 'stretch'
															},
															items: [
																{
																	xtype: 'container',
																	flex: 1,
																	id: 'spacer10'
																},
																{
																	xtype: 'button',
																	handler: function(button, event) {
																		var newUser;


																		newUser = {
																			contact_name: Ext.getCmp("newUserName").getValue(),
																			alias: Ext.getCmp("newUserAlias").getValue(),
																			email: Ext.getCmp("newUserMail").getValue(),
																			pager: Ext.getCmp("newUserPhone").getValue(),
																			type: Ext.getCmp("newUserType").getValue(),
																			language: Ext.getCmp("newUserLang").getValue(),
																			contactgroups: Ext.getCmp("newUserContactGroups").getValue(),
																			external_auth: (Ext.getCmp("newUserExternalAuth").getValue()) ? 1 : 0,
																			password: Ext.getCmp("newUserPass").getValue(),
																			password_confirm: Ext.getCmp("newUserConfPass").getValue(),
																			host_notification_options_down: 1,
																			host_notification_options_unreachable: 1,
																			host_notification_options_recovery: 1,
																			service_notification_options_warning: 1,
																			service_notification_options_unknown: 1,
																			service_notification_options_critical: 1,
																			service_notification_options_recovery: 1,
																			host_notification_options_flapping: 1,
																			service_notification_options_flapping: 1,
																			command_execution: 1,
																			tab_dashboard: 15,
																			tab_scat: 3,
																			tab_report: 63,
																			tab_monitoring: 63,
																			tab_documentation: 3,
																			tab_additionalmodule: 127,
																			tab_tool: 255,
																			theme: 'default',
																			host_notification_options_downtime: 1,
																			service_notification_options_downtime: 1,
																			tab_scats: 1,
																			tab_reports: 1,
																			tab_documentations: 1,
																			tab_additionalmodules: 1,
																			tab_tools: 1
																		};

																		if (newUser.contact_name === "") {
																			showError(l["Error"],l["Invalid username"]);
																			Ext.getCmp("newUserName").focus();
																			return;
																		}

																		if (newUser.external_auth == 0) {

																			if (newUser.password === "") {
																				showError(l["Error"],l["Invalid password"]);
																				Ext.getCmp("newUserPass").focus();
																				return;
																			}

																			if (newUser.password != newUser.password_confirm) {
																				showError(l["Error"],l["Different passwords"]);
																				Ext.getCmp("newUserPass").focus();
																				return;
																			}
																		}

																		if (newUser.type === null) {
																			showError(l["Error"],l["Invalid user type"]);
																			Ext.getCmp("newUserType").focus();
																			return;
																		}

																		if (newUser.language === null) {
																			showError(l["Error"],l["Invalid language selected"]);
																			Ext.getCmp("newUserLang").focus();
																			return;
																		}

																		afterSync = {
																			callback: function(a,b,c) {
																				store = Wizard.getApplication().getContactGroupTreeStoreStore();
																				store.getRootNode().removeAll();
																				store.load();
																				store = Wizard.getApplication().getContactTreeStoreStore();
																				store.getRootNode().removeAll();
																				store.load();

																				Ext.getCmp("newUserName").setValue("");
																				Ext.getCmp("newUserAlias").setValue("");
																				Ext.getCmp("newUserMail").setValue("");
																				Ext.getCmp("newUserPhone").setValue("");
																				Ext.getCmp("newUserPass").setValue("");
																				Ext.getCmp("newUserConfPass").setValue("");

																			}
																		};

																		Wizard.getApplication().getContactStoreStore().add(newUser);
																		Wizard.getApplication().getContactStoreStore().sync(afterSync);
																	},
																	flex: 1,
																	id: 'saveNewUser',
																	text: 'Salvar',
																	listeners: {
																		beforerender: {
																			fn: me.onSaveNewUserBeforeRender,
																			scope: me
																		}
																	}
																}
															]
														}
													]
												}
											]
										}
									]
								}
							],
							listeners: {
								beforerender: {
									fn: me.onUserPanelBeforeRender,
									scope: me
								}
							}
						}
					]
				}
			],
			dockedItems: [
				{
					xtype: 'toolbar',
					flex: 1,
					dock: 'bottom',
					baseCls: 'x-toolbar-footer',
					id: 'navBar12',
					items: [
						{
							xtype: 'tbspacer',
							flex: 1
						},
						{
							xtype: 'container',
							items: [
								{
									xtype: 'button',
									handler: function(button, event) {
										var hostGrid;
										var serviceGrid;

										grid = Ext.getCmp("contactGrid");
										if (grid !== undefined) {
											grid.getView().refresh();
										}


										grid = Ext.getCmp("serviceContactsGrid");
										if (grid !== undefined) {
											grid.getView().refresh();
										}


										makeActiveView(Wizard.lastCard);
									},
									id: 'nextBtn12',
									text: 'Salvar alterações',
									listeners: {
										beforerender: {
											fn: me.onNextBtn12BeforeRender,
											scope: me
										}
									}
								}
							]
						}
					]
				}
			]
		});

		me.callParent(arguments);
	},

	onHostGroupsTreeviewItemClick: function(dataview, record, item, index, e, eOpts) {
		Wizard.selectedRecord = record;

		if (dataview.menu === undefined) {
			dataview.menu = Ext.create("Wizard.view.removeMenu");
		}

		dataview.menu.show();
		dataview.menu.anchorTo(item.attributes['id'].nodeValue);
	},

	onHostGroupsTreePanelBeforeItemMove: function(nodeinterface, oldParent, newParent, index, eOpts) {
		var contactId;
		var from;
		var to;
		var i;
		var contact;
		var idx;
		var members;

		contactId = nodeinterface.data.contactgroup_id;
		to = newParent.data.contactgroup_name;
		from = oldParent.data.contactgroup_name;

		if (contactGroupNodeHasContact(newParent, nodeinterface.data.contactgroup_name)) {
			showInfo("Contact already present","Target contactgroup already contains contact");
			return false;
		}

		idx = indexOfObject(newParent.get("members"), "contactgroup_id", contactId);
		if (idx >= 0) {
			return false;
		}

		members = oldParent.get("members");
		members.splice(idx, 1);
		oldParent.set("members",members);

		Ext.getCmp('teamsTreePanel').disable();
		Ext.Ajax.request({

			url: '/opmon/seagull/www/index.php/discovery/action/contactgroups/operation/contactchangedcontactgroup/',
			method: 'POST',
			params: {
				contact_name: nodeinterface.data.contactgroup_name,
				from: from,
				to: to
			},
			success: function(result,request) {
				var obj;

				obj = JSON.parse(result.responseText);
				if (!obj) {
					showError(
					"Unexpected error",
					"Unable to parse json"
					);
					return;
				}

				if (!obj.success) {
					showError(
					"Unexpected error",
					obj.message
					);
					return;
				}

				Ext.getCmp('teamsTreePanel').enable();

				store = Wizard.getApplication().getContactTreeStoreStore();
				store.getRootNode().removeAll();
				store.load();


			},
			failure: function(result, request) {
				showError(
				"Unexpected error",
				"Unable to reach server"
				);
			}

		});

		return true;
	},

	onApplyContactGroupClick: function(button, e, eOpts) {
		contactgroupId = Ext.getCmp('addUserTeamTeam').getValue();
		contactsIds = Ext.getCmp('addUserTeamUser').getValue();
		contactStore = Wizard.getApplication().getContactStoreStore();

		application = Wizard.getApplication();
		treeStore = Ext.getCmp('teamsTreePanel').getStore();

		contactgroup = treeStore.getById(contactgroupId);
		if (!contactgroup) {
			showError("Error","Unable to locate your contact group node");
			return;
		}

		Ext.getCmp('teamsTreePanel').disable();

		members = contactgroup.get("members");
		validContacts = [];
		for(i=0; i<contactsIds.length; i++) {

			/* contact group has contact amongst its members */
			if (indexOfObject(members, "contact_id", contactsIds[i]) >= 0) {
				continue;
			}

			c = contactStore.getById(contactsIds[i]);
			if (!c) {
				/* well, this is not supposed to happen */
				continue;
			}

			validContacts.push(contactsIds[i]);
			contact = {
				contactgroup_name: c.get("contact_name"),
				contact_name: c.get("contact_name"),
				contactgroup_id: getUniqId(),
				contact_id: contactsIds[i],
				leaf: true
			};

			members.push(contact);
			contactgroup.appendChild(contact);
		}

		contactgroup.set("members",members);
		if (validContacts.length >= 1) {
			addContactsToContactgroupOnServer(validContacts,contactgroupId);
		}

		store = Wizard.getApplication().getContactTreeStoreStore();
		store.getRootNode().removeAll();
		store.load();
	},

	onLabelBeforeRender: function(component, eOpts) {
		component.text = l["Set the parameters of the team"];
	},

	onNewTeamNameBlur: function(component, e, eOpts) {
		component.setValue(
			changeCharCode(component.getValue())
		);
	},

	onNewTeamNameBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Name"];
	},

	onNewTeamAliasBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Description"];
	},

	onNewTeamUsersBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Contacts"];
	},

	onSaveNewTeamBeforeRender: function(component, eOpts) {
		component.text = l["Save"];
	},

	onTeamPanelBeforeRender: function(component, eOpts) {
		component.title = l["Contactgroups"];
	},

	onViewItemClick: function(dataview, record, item, index, e, eOpts) {
		Wizard.selectedRecord = record;

		if (dataview.menu === undefined) {
			dataview.menu = Ext.create("Wizard.view.removeMenu");
		}

		dataview.menu.show();
		dataview.menu.anchorTo(item.attributes['id'].nodeValue);
	},

	onServiceGroupsTreePanelBeforeItemMove: function(nodeinterface, oldParent, newParent, index, eOpts) {

		contactGroupName = nodeinterface.raw.contactgroup_name;
		from = oldParent.raw.contact_name;
		to = newParent.raw.contact_name;

		console.log(contactGroupName);


		params = {
			contactgroup_name: contactGroupName,
			contact_name: from
		};

		Ext.Ajax.request({
			url: '/opmon/seagull/www/index.php/discovery/action/contacts/operation/removecontactgroupfromcontact/',
			method: 'POST',
			params: params,

			success: function(result,request) {

				var obj;

				obj = JSON.parse(result.responseText);
				if (!obj) {
					showError(l["Unexpected error"], l["JSON not found"]);
					return;
				}

				if (!obj.success) {
					showError(l["Unexpected error"],obj.message);
					return;
				}

				Ext.Ajax.request({

					url: '/opmon/seagull/www/index.php/discovery/action/contacts/operation/addcontactgrouptocontact/',
					method: 'POST',
					params: {
						contactgroup_name: contactGroupName,
						contact_name: to
					},
					success: function(result,request) {
						var obj;

						obj = JSON.parse(result.responseText);
						if (!obj) {
							showError(l["Unexpected error"],l["JSON not found"]);
							return;
						}

						if (!obj.success) {
							showError(l["Unexpected error"],obj.message);
							return;
						}

						store = Wizard.getApplication().getContactGroupTreeStoreStore();
						store.getRootNode().removeAll();
						store.load();

					},
					failure: function(result, request) {
						showError(l["Unexpected error"],l["Connection Error"]);
					}

				});


			},
			failure: function(result, request) {
				showError(
				"Unexpected error",
				"Unable to reach server"
				);
			}


		});
	},

	onLabelBeforeRender1: function(component, eOpts) {
		component.text = l["Contacts"];
	},

	onNewUserNameBlur: function(component, e, eOpts) {
		component.setValue(
			changeCharCode(component.getValue())
		);
	},

	onNewUserNameBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Name"];
	},

	onNewUserAliasBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Description"];
	},

	onNewUserPhoneBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Mobile"];
	},

	onNewUserTypeBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Type"];
	},

	onNewUserLangBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["User_Language"];
	},

	onNewUserContactGroupsBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Contactgroups"];
	},

	onNewUserExternalAuthChange: function(field, newValue, oldValue, eOpts) {
		if (newValue) {
			Ext.getCmp("newUserPass").hide();
			Ext.getCmp("newUserConfPass").hide();
			return;
		}

		Ext.getCmp("newUserPass").show();
		Ext.getCmp("newUserConfPass").show();
	},

	onNewUserExternalAuthBeforeRender: function(component, eOpts) {
		component.boxLabel = l["Using external authentication"];
	},

	onNewUserPassBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Password"];
	},

	onNewUserConfPassBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Confirm password"];
	},

	onSaveNewUserBeforeRender: function(component, eOpts) {
		component.text = l["Save"];
	},

	onUserPanelBeforeRender: function(component, eOpts) {
		component.title = l["Contacts"];
	},

	onNextBtn12BeforeRender: function(component, eOpts) {
		component.text = l.Complete;
	}

});