/*
 * File: app/view/selectCommand.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.view.selectCommand', {
	extend: 'Ext.window.Window',

	requires: [
		'Ext.form.Panel',
		'Ext.form.field.ComboBox',
		'Ext.form.Label',
		'Ext.toolbar.Toolbar',
		'Ext.button.Button',
		'Ext.toolbar.Spacer'
	],

	draggable: false,
	height: 370,
	id: 'selectCommandWindow',
	width: 600,
	layout: 'accordion',
	title: 'Adicionar Comando ao Serviço',
	modal: true,

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'form',
					cls: 'wizard-accordion',
					id: 'commandSelectPanel',
					bodyPadding: '20 20 0',
					collapsible: true,
					glyph: 49,
					title: 'Selecione um comando',
					layout: {
						type: 'vbox',
						align: 'stretch'
					},
					items: [
						{
							xtype: 'combobox',
							flex: 1,
							height: 22,
							id: 'commandSelector',
							maxHeight: 22,
							minHeight: 22,
							fieldLabel: '',
							hideLabel: true,
							labelWidth: 160,
							emptyText: 'Selecione um comando disponível',
							anyMatch: true,
							displayField: 'command_line',
							forceSelection: true,
							queryMode: 'local',
							store: 'commandStore',
							valueField: 'command_id',
							listeners: {
								change: {
									fn: me.onCommandSelectorChange,
									scope: me
								},
								beforerender: {
									fn: me.onCommandSelectorBeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'container',
							cls: 'grey-bg',
							id: 'commandData',
							padding: '10 20',
							items: [
								{
									xtype: 'label',
									id: 'commandLine',
									margin: '5 0 0',
									text: ''
								}
							]
						}
					],
					dockedItems: [
						{
							xtype: 'toolbar',
							flex: 1,
							dock: 'bottom',
							layout: {
								type: 'hbox',
								padding: '0 10'
							},
							items: [
								{
									xtype: 'button',
									handler: function(button, event) {
										Ext.create(Wizard.view.createCommand).show();
									},
									id: 'addNewCommandBtn',
									glyph: 43,
									text: 'Adicionar um novo comando à lista',
									listeners: {
										beforerender: {
											fn: me.onAddNewCommandBtnBeforeRender,
											scope: me
										}
									}
								}
							]
						}
					],
					listeners: {
						beforerender: {
							fn: me.onCommandSelectPanelBeforeRender,
							scope: me
						}
					}
				},
				{
					xtype: 'form',
					cls: 'wizard-accordion',
					id: 'commandArgsPanel',
					autoScroll: true,
					glyph: 50,
					title: 'Defina os argumentos do comando selecionado',
					layout: {
						type: 'vbox',
						align: 'stretch'
					},
					dockedItems: [
						{
							xtype: 'container',
							flex: 1,
							dock: 'top',
							minHeight: 36,
							padding: '10 20',
							layout: {
								type: 'vbox',
								align: 'stretch'
							},
							items: [
								{
									xtype: 'container',
									flex: 1,
									cls: 'grey-bg',
									padding: '10 20',
									items: [
										{
											xtype: 'label',
											id: 'commandWithArgs'
										}
									]
								}
							]
						}
					],
					items: [
						{
							xtype: 'container',
							flex: 1,
							id: 'parametersContainer',
							margin: '0 20 0',
							padding: '2 20 2 0',
							autoScroll: true,
							layout: {
								type: 'vbox',
								align: 'stretch'
							}
						}
					],
					listeners: {
						beforeexpand: {
							fn: me.onCommandArgsPanelBeforeExpand,
							scope: me
						},
						beforerender: {
							fn: me.onCommandArgsPanelBeforeRender,
							scope: me
						}
					}
				},
				{
					xtype: 'form',
					cls: 'wizard-accordion',
					id: 'testCommand',
					autoScroll: true,
					bodyPadding: 20,
					glyph: 51,
					title: 'Teste o comando',
					layout: {
						type: 'vbox',
						align: 'stretch'
					},
					items: [
						{
							xtype: 'container',
							layout: {
								type: 'hbox',
								align: 'stretch'
							},
							items: [
								{
									xtype: 'combobox',
									flex: 2,
									autoShow: true,
									height: 36,
									id: 'hostTest',
									maxHeight: 20,
									padding: '0 10 0 0',
									fieldLabel: 'Selecione um host',
									labelSeparator: ' ',
									labelWidth: 120,
									allowBlank: false,
									displayField: 'host_name',
									forceSelection: true,
									queryMode: 'local',
									store: 'hostStore',
									valueField: 'host_name',
									listeners: {
										beforerender: {
											fn: me.onHostTestBeforeRender,
											scope: me
										}
									}
								},
								{
									xtype: 'button',
									handler: function(button, event) {
										me = Ext.getCmp("selectCommandWindow");

										if (me.isSelectedCommandValid() === false) {
											return;
										}

										if (me.isSelectedHostValid() === false) {
											return;
										}

										me.doTestCommand();
									},
									height: 24,
									id: 'testCommandButton',
									maxHeight: 24,
									minHeight: 24,
									text: 'Testar comando',
									listeners: {
										beforerender: {
											fn: me.onTestCommand4BeforeRender,
											scope: me
										}
									}
								}
							]
						},
						{
							xtype: 'container',
							cls: 'green-bg',
							margin: '5 0 0',
							padding: '10 20',
							items: [
								{
									xtype: 'label',
									text: 'Standard Output: '
								},
								{
									xtype: 'label',
									id: 'stdOut',
									text: ''
								}
							]
						},
						{
							xtype: 'container',
							cls: 'red-bg',
							margin: '5 0 0',
							padding: '10 20',
							items: [
								{
									xtype: 'label',
									text: 'Standard Error: '
								},
								{
									xtype: 'label',
									id: 'stdErr',
									text: ''
								}
							]
						}
					],
					listeners: {
						beforerender: {
							fn: me.onTestCommandBeforeRender,
							scope: me
						},
						expand: {
							fn: me.onTestCommandExpand,
							scope: me
						}
					}
				}
			],
			dockedItems: [
				{
					xtype: 'toolbar',
					dock: 'bottom',
					baseCls: 'x-toolbar-footer',
					id: 'navBar6',
					items: [
						{
							xtype: 'button',
							handler: function(button, event) {
								Ext.getCmp('selectCommandWindow').close();
							},
							id: 'prevBtn10',
							text: 'Voltar',
							listeners: {
								beforerender: {
									fn: me.onPrevBtn10BeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'tbspacer',
							flex: 1
						},
						{
							xtype: 'container',
							items: [
								{
									xtype: 'button',
									handler: function(button, event) {
										me = Ext.getCmp("selectCommandWindow");

										if (me.isSelectedCommandValid() === false) {
											showError(l.Error,l["Please select a command"]);
											return;
										}

										me.updateBuckets();

										grid = Ext.getCmp('serviceGrid');
										if (grid !== undefined) {
											grid.rerenderBuckets();
										}

										/* close windows */
										try {

											var w = Ext.getCmp('selectCommandWindow');
											if (w !== undefined) {
												w.close();
											}

											w = Ext.getCmp('newService');
											if (w !== undefined) {
												w.close();
											}

											w = Ext.getCmp('newService1');
											if (w !== undefined) {
												w.close();
											}
										} catch(e) {
											/*no time*/
										}

										showInfo(l.Information,l["Command submitted successfully"]);

										if (me.callback !== undefined) {
											me.callback(me.somethingHasChanged, me.bucket);
										}
									},
									id: 'nextBtn5',
									text: 'Aplicar comando ao serviço',
									listeners: {
										beforerender: {
											fn: me.onNextBtn5BeforeRender,
											scope: me
										}
									}
								}
							]
						}
					]
				}
			],
			listeners: {
				show: {
					fn: me.onSelectCommandWindowShow,
					scope: me
				},
				beforerender: {
					fn: me.onSelectCommandWindowBeforeRender,
					scope: me
				}
			}
		});

		me.callParent(arguments);
	},

	onCommandSelectorChange: function(field, newValue, oldValue, eOpts) {
		me = Ext.getCmp("selectCommandWindow");

		if (me.isSelectedCommandValid() === false) {
			return;
		}

		me.updateCommandLines();
		me.somethingHasChanged = true;
		Ext.getCmp("selectCommandWindow").createParameterFields();
		Ext.getCmp("selectCommandWindow").parameterChanged();
	},

	onCommandSelectorBeforeRender: function(component, eOpts) {
		component.emptyText = l["Select an available command"];
	},

	onAddNewCommandBtnBeforeRender: function(component, eOpts) {
		component.text = l["Add a new command to the list"];
	},

	onCommandSelectPanelBeforeRender: function(component, eOpts) {
		component.title = l["Select a command"];
	},

	onCommandArgsPanelBeforeExpand: function(p, animate, eOpts) {
		if (cid === undefined || cid === null) {
			return;
		}

		Ext.getCmp("selectCommandWindow").createParameterFields();
		Ext.getCmp("selectCommandWindow").parameterChanged();
	},

	onCommandArgsPanelBeforeRender: function(component, eOpts) {
		component.title = l["Set the arguments of the selected command"];
	},

	onHostTestBeforeRender: function(component, eOpts) {
		component.fieldLabel = l["Select a host"];
	},

	onTestCommand4BeforeRender: function(component, eOpts) {
		component.text = l["Test command"];
	},

	onTestCommandBeforeRender: function(component, eOpts) {
		component.title = l["Test command"];
	},

	onTestCommandExpand: function(p, eOpts) {
		bucket = Ext.getCmp("selectCommandWindow").bucket;
		store = Ext.getCmp("hostTest").getStore();

		if (store.find("host_name", bucket.host_name) >= 0) {
			Ext.getCmp("hostTest").setValue(bucket.host_name);
		}


	},

	onPrevBtn10BeforeRender: function(component, eOpts) {
		component.text = l["Back"];
	},

	onNextBtn5BeforeRender: function(component, eOpts) {
		component.text = l["Apply"];
	},

	onSelectCommandWindowShow: function(component, eOpts) {
		if (component.bucket === undefined) {
			showError("Error","no bucket");
			return;
		}

		Ext.getCmp("commandSelector").setValue(component.bucket.check_command); /* cascade events */

		hosts = Wizard.getApplication().getHostStoreStore();
		if (hosts.getCount() === 0) {
			hosts = Wizard.getApplication().getAlreadyMonitoredHostStoreStore();
		}

		var host = hosts.getAt(0);
		Ext.getCmp("hostTest").bindStore(hosts);
		Ext.getCmp("hostTest").setValue(host.get("host_name"));

		me.somethingHasChanged = false;
	},

	onSelectCommandWindowBeforeRender: function(component, eOpts) {
		component.setTitle(l["Advanced commands"]);
	},

	addServiceBucket: function(bucket) {
		me = Ext.getCmp("selectCommandWindow");
		me.bucket = bucket;
	},

	createParameterFields: function() {
		// me is selectCommand window
		me = Ext.getCmp("selectCommandWindow");

		command = me.getSelectedCommand();
		paramContainer = Ext.getCmp("parametersContainer");
		count = command.get("command_line").match(/\$ARG\d+\$/g);

		paramContainer.removeAll(true);
		me.commandParameters = [];
		if (count === null) {
			return;
		}

		editServicesWindow = Ext.getCmp("editServices");

		params = me.bucket.check_parameters;
		for (i=0; i<count.length; i++) {

			var field = Ext.create("Wizard.view.parameterField");
			field.setFieldLabel(count[i]);
			var aux = count[i].match(/.+ARG(\d+)\$.*$/);
			if (aux.length != 2) {
				continue;
			}

			var pidx = parseInt(aux[1]);
			if (isNaN(pidx))
				continue;

			pidx--;
			if (pidx >= 0 && params && params[pidx] !== undefined)
				field.setValue(params[pidx]);

			paramContainer.add(field);
			me.commandParameters.push(field);
		}
	},

	isSelectedCommandValid: function() {
		commandStore = Wizard.getApplication().getCommandStoreStore();
		cid = commandStore.getById(Ext.getCmp('commandSelector').getValue());

		if (cid === null) {
			return false;
		}

		return true;
	},

	getSelectedCommand: function() {
		commandStore = Wizard.getApplication().getCommandStoreStore();
		cid = commandStore.getById(Ext.getCmp('commandSelector').getValue());
		return cid;
	},

	updateCommandLines: function() {
		Ext.getCmp("commandLine").setText(cid.get("command_line"));
		Ext.getCmp("commandWithArgs").setText(cid.get("command_line"));
	},

	parameterChanged: function() {
		me = Ext.getCmp("selectCommandWindow");

		if (me.commandParameters === undefined || me.commandParameters.length === 0) {
			return;
		}

		commandLine = Ext.getCmp("commandLine").text;
		for(i=0; i<me.commandParameters.length; i++) {
			field = me.commandParameters[i];
			if (field.getValue() === "") {
				continue;
			}
			commandLine = commandLine.replace(field.getFieldLabel(), field.getValue());
		}
		Ext.getCmp("commandWithArgs").setText(commandLine);
	},

	isSelectedHostValid: function() {
		if (Ext.getCmp('hostTest').getValue() === null) {
			showError(l["Invalid host"],l["Please select a host to be tested"]);
			return false;
		}

		return true;
	},

	getCommandParameters: function() {
		me = Ext.getCmp("selectCommandWindow");

		commandParameters = {};

		if (me.commandParameters !== undefined) {
			for (i=0; i<me.commandParameters.length; i++) {
				field = me.commandParameters[i];
				commandParameters[field.getFieldLabel()] = field.getValue();
			}
		}

		return commandParameters;
	},

	doTestCommand: function() {
		me = Ext.getCmp("selectCommandWindow");

		commandId = me.getSelectedCommand().get("command_id");
		params = me.getCommandParameters();
		host = me.getSelectedHost();
		Ext.getCmp("testCommandButton").disable();


		Ext.Ajax.request({
			url: '/opmon/seagull/www/index.php/discovery/action/runcommand/',
			method: 'POST',
			params: {
				command_id: commandId,
				host: JSON.stringify(host.raw),
				parameters: JSON.stringify(params)
			},
			success: function(result, request) {
				var wsreturn;
				Ext.getCmp("testCommandButton").enable();

				try {
					wsreturn = JSON.parse(result.responseText);
				} catch(err){
					showError(l["Unexpected error"],err.message);
					return;
				}

				if (!wsreturn.success) {
					showError(l["Unexpected error"],wsreturn.message);
					return;
				}

				Ext.getCmp('stdOut').setText(wsreturn.std_out);
				Ext.getCmp('stdErr').setText(wsreturn.std_err);

			},
			failure: function(result, request) {
				Ext.getCmp('stdErr').setText("timeout");
				Ext.getCmp("testCommandButton").enable();
			}
		});
	},

	getSelectedHost: function() {
		hostStore = Ext.getCmp("hostTest").getStore();
		hostPos = hostStore.find("host_name",Ext.getCmp('hostTest').getValue());
		return hostStore.getAt(hostPos);
	},

	getCommandParametersAsArray: function() {
		me = Ext.getCmp("selectCommandWindow");
		params = [];

		if (me.commandParameters === undefined) {
			return params;
		}

		for (i=0; i<=me.commandParameters.length; i++) {
			params[i] = null;
		}

		for (i=0; i<me.commandParameters.length; i++) {

			field = me.commandParameters[i];

			regexret = field.getFieldLabel().match(/^\$ARG(\d+)\$/);
			if (regexret[1] === undefined) {
				continue;
			}

			pos = parseInt(regexret[1], 10);
			params[pos] = field.getValue();
		}

		params_wo_null = [];
		Ext.each(params, function(p){
			if (p === null) {
				return;
			}

			params_wo_null.push(p);
		});


		return params_wo_null;
	},

	updateBuckets: function() {
		var me = Ext.getCmp("selectCommandWindow");

		var params = me.getCommandParametersAsArray();
		me.bucket.check_command = Ext.getCmp('commandSelector').getValue();
		if (params !== undefined) {
			me.bucket.check_parameters = params;
		} else {
			me.bucket.check_parameters = [];
		}
	},

	setCallBack: function(cb) {
		me = Ext.getCmp("selectCommandWindow");
		me.callback = cb;
	}

});