/*
 * File: app/view/selectTemplates.js
 *
 * This file was generated by Sencha Architect
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('Wizard.view.selectTemplates', {
	extend: 'Ext.panel.Panel',
	alias: 'widget.selecttemplates',

	requires: [
		'Ext.grid.Panel',
		'Ext.grid.column.Column',
		'Ext.grid.View',
		'Ext.selection.CheckboxModel',
		'Ext.button.Button',
		'Ext.toolbar.Toolbar',
		'Ext.toolbar.Spacer'
	],

	height: 500,
	id: 'selectTemplates',
	width: 800,
	title: 'Selecione os templates que deseja aplicar aos hosts em edição',

	layout: {
		type: 'vbox',
		align: 'stretch'
	},

	initComponent: function() {
		var me = this;

		Ext.applyIf(me, {
			items: [
				{
					xtype: 'gridpanel',
					flex: 1,
					id: 'selectTemplatesGrid',
					autoScroll: true,
					header: false,
					title: 'Selecione os templates que deseja aplicar aos hosts em edição',
					forceFit: true,
					store: 'templateStore',
					columns: [
						{
							xtype: 'gridcolumn',
							dataIndex: 'template_name',
							text: 'Template',
							flex: 1,
							listeners: {
								beforerender: {
									fn: me.onGridcolumnBeforeRender1,
									scope: me
								}
							}
						},
						{
							xtype: 'gridcolumn',
							renderer: function(value, metaData, record, rowIndex, colIndex, store, view) {
								var i;
								var service;
								var services = [];

								for(i=0; i<value.length; i++) {
									service = value[i];
									services.push(service.service_description);
								}
								return services.join(", ");
							},
							dataIndex: 'services',
							text: 'Serviços do template',
							flex: 3,
							listeners: {
								beforerender: {
									fn: me.onGridcolumnBeforeRender,
									scope: me
								}
							}
						}
					],
					viewConfig: {
						minHeight: 210
					},
					selModel: Ext.create('Ext.selection.CheckboxModel', {
						toggleOnClick: false,
						ignoreRightMouseSelection: true,
						checkOnly: true,
						showHeaderCheckbox: true
					}),
					dockedItems: [
						{
							xtype: 'container',
							dock: 'bottom',
							hidden: true,
							id: 'gridButtonBar',
							padding: 8,
							width: 100,
							items: [
								{
									xtype: 'button',
									hidden: true,
									text: 'Adicionar novo template'
								}
							]
						}
					],
					listeners: {
						beforerender: {
							fn: me.onSelectTemplatesGridBeforeRender,
							scope: me
						}
					}
				}
			],
			dockedItems: [
				{
					xtype: 'toolbar',
					dock: 'bottom',
					baseCls: 'x-toolbar-footer',
					id: 'navBar9',
					items: [
						{
							xtype: 'button',
							handler: function(button, event) {
								makeActiveView('step01');
							},
							id: 'prevBtn12',
							text: 'Cancelar',
							listeners: {
								beforerender: {
									fn: me.onPrevBtn12BeforeRender,
									scope: me
								}
							}
						},
						{
							xtype: 'tbspacer',
							flex: 1
						},
						{
							xtype: 'container',
							items: [
								{
									xtype: 'button',
									handler: function(button, event) {
										var hostStore;
										var host;
										var i;
										var j;
										var k;
										var selectedTemplates;
										var serviceGrid;
										var label = [];

										selectedTemplates = Ext.getCmp("selectTemplatesGrid").getSelectionModel().getSelection();
										hostStore = Wizard.getApplication().getHostStoreStore();

										for(i=0; i<hostStore.getCount(); i++) {
											host = hostStore.getAt(i);
											for(j=0; j<selectedTemplates.length; j++) {

												if (label.indexOf(selectedTemplates[j].get("template_name")) < 0) {
													label.push(selectedTemplates[j].get("template_name"));
												}

												for(k=0; k<selectedTemplates[j].raw.services.length; k++) {
													selectedTemplates[j].raw.services[k].selected = true;
													host.addService(selectedTemplates[j].raw.services[k]);
												}
											}
										}


										if (label.length > 0) {
											Ext.getCmp("selectTemplatesNamesText").setText(label.join(", "));
											//Ext.getCmp("selectTemplatesNamesText1").setText(label.join(", "));
										}


										createServicesUniqList();
										serviceGrid = Ext.getCmp("serviceGrid");
										if (serviceGrid !== undefined) {
											serviceGrid.getView().refresh();
										}

										makeActiveView('step01');
									},
									id: 'nextBtn9',
									text: 'Aplicar templates selecionados aos hosts',
									listeners: {
										beforerender: {
											fn: me.onNextBtn9BeforeRender,
											scope: me
										}
									}
								}
							]
						}
					]
				}
			],
			listeners: {
				beforerender: {
					fn: me.onSelectTemplatesBeforeRender,
					scope: me
				}
			}
		});

		me.callParent(arguments);
	},

	onGridcolumnBeforeRender1: function(component, eOpts) {
		component.text = l["Template name"];
	},

	onGridcolumnBeforeRender: function(component, eOpts) {
		component.text = l["Services template"];
	},

	onSelectTemplatesGridBeforeRender: function(component, eOpts) {
		component.title = l["Select the templates you want to apply to hosts in the editing"];
	},

	onPrevBtn12BeforeRender: function(component, eOpts) {
		component.text = l["Cancel"];
	},

	onNextBtn9BeforeRender: function(component, eOpts) {
		component.text = l["Apply templates to selected hosts"];
	},

	onSelectTemplatesBeforeRender: function(component, eOpts) {
		component.title = l["Select the templates you want to apply to hosts in the editing"];
	}

});