var explodedMessage = "Please contact OpServices.";
var explodedTitle = "Error";
var randomIds = [];
var viewPortItems = [];

function getUniqId() {
	var random;
	var tries;

	random = null;
	tries = 0;
	do {
		random = "random_" + Math.floor(Math.random()*50000) + Math.floor(Math.random()*50000) + Math.floor(Math.random()*50000) + Math.floor(Math.random()*50000);
		tries++;
	} while (randomIds.indexOf(random) != -1 && tries < 10000);

	if (tries === 10000) {
		showError( "Instability time", "We ran out of uinq ids");
	}

	randomIds.push(random);
	return random;
}

function contactGroupNodeHasContact(node, contactName) {

	var found;
	var i;

	found = false;
	for(i=0; i<node.childNodes.length; i++) {
		if (node.childNodes[i].data.contactgroup_name == contactName) {
			found = true;
			break;
		}
	}

	return found;	
}



function getMonitoredHostById(id) {
	var application;
	var hostStore;
	application = Wizard.getApplication();
	hostStore = application.getAlreadyMonitoredHostStoreStore();
	return hostStore.getById(id);
}

function getMonitoredServiceById(id) {
	var application;
	var serviceStore;
	application = Wizard.getApplication();
	serviceStore = application.getAlreadyMonitoredServiceStoreStore();
	return serviceStore.getById(id);
}

function getHostById(id) {
	var application;
	var hostStore;
	application = Wizard.getApplication();
	hostStore = application.getHostStoreStore();
	return hostStore.getById(id);
}

function getContactById(id) {
	var application;
	var contactStore;
	application = Wizard.getApplication();
	contactStore = application.getContactStoreStore();
	return contactStore.getById(id);
}

function closeWizardWindows() {
	var i;
	var cmp;

	i = Wizard.openedWindows.length - 1;
	for(; i>=0; i--) {
		cmp = Ext.getCmp(Wizard.openedWindows[i]);	
		if (cmp) {
			cmp.close();
		}
	}

}

function getContactByName(name) {
	var application;
	var contactStore;
	var idx;
	application = Wizard.getApplication();
	contactStore = application.getContactStoreStore();
	idx = contactStore.find("contact_name",name);
	if (idx < 0) {
		return null;
	}
	return contactStore.getAt(idx);
}


function getHostGroupById(id) {
	var application;
	var hostStore;
	application = Wizard.getApplication();
	hostStore = application.getHostGroupStoreStore();
	return hostStore.getById(id);
}

function getMonitoredHostByName(hostName) {
	var application;
	var hostStore;
	var i;
	var h;

	application = Wizard.getApplication();
	hostStore = application.getAlreadyMonitoredHostStoreStore();
	for(i=0; i<hostStore.data.items.length; i++) {
		h = hostStore.data.items[i];
		if (h.get("host_name") == hostName) {
			return h;	
		}
	}

	return null;

}


function getHostByName(hostName) {
	var application;
	var hostStore;
	var i;
	var h;

	application = Wizard.getApplication();
	hostStore = application.getHostStoreStore();
	for(i=0; i<hostStore.data.items.length; i++) {
		h = hostStore.data.items[i];
		if (h.get("host_name") == hostName) {
			return h;	
		}
	}

	return null;	
}

function getServiceGroupByName(serviceGroupName) {
	var application;
	var serviceGroupStore;
	var pos;

	application = Wizard.getApplication();
	serviceGroupStore = application.getServiceGroupStoreStore();
	pos = serviceGroupStore.find("servicegroup_name", serviceGroupName);
	if (pos < 0) {
		return null;
	}

	return serviceGroupStore.getAt(pos);
}

function getMonitoredServiceByName(hostName, serviceDescription) {
	var serviceStore;
	var host;
	var i;
	var service;

	serviceStore = Wizard.getApplication().getAlreadyMonitoredServiceStoreStore();
	for(i=0; i<serviceStore.data.items.length; i++) {
		service = serviceStore.data.items[i];
		if (service.get("service_description") != serviceDescription) {
			continue;
		}

		host = getMonitoredHostById(service.get("host_id"));
		if (host === null) {
			continue;
		}

		if (host.get("host_name") == hostName) {
			return service;	
		}
	}

	return null;
}


function getContactGroupByName(contactGroupName) {
	var application;
	var contactGroupStore;
	var i;
	var h;

	application = Wizard.getApplication();
	contactGroupStore = application.getContactGroupStoreStore();
	for(i=0; i<contactGroupStore.getCount(); i++) {
		h = contactGroupStore.data.items[i];
		if (h.get("contactgroup_name") == contactGroupName) {
			return h;	
		}
	}

	showError(
		"Search contactgroup error",
		"Unable to locate contactgroup " + contactGroupName
	);
	return null;
}


function getHostGroupByName(hostGroupName) {
	var application;
	var hostGroupStore;
	var i;
	var h;

	application = Wizard.getApplication();
	hostGroupStore = application.getHostGroupStoreStore();
	for(i=0; i<hostGroupStore.data.items.length; i++) {
		h = hostGroupStore.data.items[i];
		if (h.get("hostgroup_name") == hostGroupName) {
			return h;	
		}
	}

	showError(
		"Search host error",
		"Unable to locate hostgroup " + hostGroupName
	);
	return null;
}


function removeHostGroupOnHost(host, hostGroup) {
	var newhostgroups;
	var hostgroups;
	var i;

	if (!host || !hostGroup) {
		return false;	
	}

	newhostgroups = [];
	hostgroups = host.get("hostgroups");
	for(i=0; i<hostgroups.length; i++) {
		if (hostgroups[i] != hostGroup.get("hostgroup_id"))	{
			newhostgroups.push(hostgroups[i]);
		}
	}

	host.set("hostgroups",newhostgroups);
	return true;
}

function addHostGroupOnHost(host, hostGroup) {
	var hostgroups;

	if (!host || !hostGroup) {
		return false;	
	}

	hostgroups = host.get("hostgroups");
	if (hostgroups.indexOf(hostGroup.get("hostgroup_id")) < 0) {
		hostgroups.push(hostGroup.get("hostgroup_id"));	
	}

	return true;
}

function destroyPopUp() {
	func = "parent."+Wizard.endCallBack+"(true);";
	console.log("parent."+Wizard.endCallBack+"(true);");
	eval(func);

}

function showError(title, msg, dump, destroyParent) {

	if (!title) {
		title = explodedTitle;
	}

	if (!msg) {
		var err = new Error();
		msg = explodedMessage + "<br />" + err.stack.replace(/\n/g, '<br />');	
	}

	Ext.MessageBox.show({ 
		title: title,
		msg: msg,
		icon: Ext.MessageBox.ERROR,
		closable: true,
		listeners: {
			beforeshow: function(){
				console.log("show!");
			},
			beforeclose: function() {
				console.log("ta entrando aqui?");
				if (destroyParent) {
					destroyPopUp();
				}
			}
		}

	});

	if (dump) {
		console.log(dump);
	}
}


function showInfo(title, msg) {
	Ext.MessageBox.show({ 
		title: title,
		msg: msg,
		icon: Ext.MessageBox.INFO,
		closable: true
	});
	setTimeout(function(){Ext.MessageBox.hide();},3000);
}

function removeHostGroupById(hostgroupId) {
	var hg;
	var hostGroupStore;


	hg = getHostGroupById(hostgroupId);
	if (hg === null) {
		return;
	}

	hostGroupStore = Wizard.getApplication().getHostGroupStoreStore();
	hostGroupStore.remove(hg);

}


function addServicesToServicegroupOnServer(servicesIds,servicegroupId) {

	var params;


	if (servicesIds.length == 0) {
		Ext.getCmp('serviceGroupsTreePanel').enable();
		return;	
	}

	Ext.getCmp('serviceGroupsTreePanel').disable();

	params = {
		servicegroup_id: servicegroupId,
		services: JSON.stringify(servicesIds)
	};

	Ext.Ajax.request({

		url: '/opmon/seagull/www/index.php/discovery/action/servicegroups/operation/addservicestoservicegroup/',
		method: 'POST',
		params: params,
		success: function(result, request) {

			var obj;

			obj = JSON.parse(result.responseText);
			if (!obj) {
				showError(
					"Unexpected error",
					"Unable parse",
					result.responseText
				);
				return;
			}

			if (!obj.success) {
				showError(
					"Unexpected error",
					obj.message,
					obj
				);
				return;			
			}

			Ext.getCmp('serviceGroupsTreePanel').enable();

		},
		failure: function(result, request) {
			showError(
				"Unexpected error",
				"Unable to reach server"
			);
		}

	});
}

function createServicesUniqList() {
	var serviceStore;
	var hostStore;
	var service;

	// n^2 :(
	serviceStore = Wizard.getApplication().getServiceStoreStore();
	hostStore = Wizard.getApplication().getHostStoreStore();

	serviceStore.removeAll();
	for(i=0; i<hostStore.getCount(); i++) {

		host = hostStore.getAt(i);
		var services = host.get("services");
		for(j=0; j<services.length; j++) {

			service = services[j];
			var pos = serviceStore.find("service_description", service.service_description);
			if (pos < 0 || pos === null) {function verifyLicense(elementToVerify){
				var licensestore = Ext.getStore("licenseStore");

				if (licenseStore.getAt(0).get('licensed')) {
					selectedHostName = Ext.getCmp('discoveredHostHostName').getValue();
					var lic = licenseStore.getAt(0);
					console.log(lic);
					var licenseLimit = lic.get(elementToVerify + 's_limit');
					var licenseMonitored = lic.get(elementToVerify + 's_monitored');
					var totalHostsSelected = selectedHostName.length;
					var totalHost = licenseMonitored + totalHostsSelected;
					console.log(Ext.getCmp('discoveredHostHostName'));
					console.log(licenseStore.getAt(0));

					if (lic.get(licenseLimit) == "Unlimited") {
						console.log("Licença para host ilimitado...");
						return;
					}


					if (licenseMonitored + totalHostsSelected > licenseLimit){

						console.log("Limite excedido");
						var translatedtext = t("licenseExceededMsgHosts")
						.replace("%HOSTSELECTED%", licenseMonitored )
						.replace("%LICENSELIMIT%",licenseLimit)
						.replace("%LICENSEMONITORED%",totalHostsSelected);

						Ext.Msg.show({
							title: "Limite de licença atingido",
							buttons: Ext.Msg.OK,
							icon: Ext.Msg.ERROR,
							msg: translatedtext,
						});

						return false;
					}
				}
				return true;
			}

										  serviceStore.add(service);
										  continue;	
										 }

			var aux = serviceStore.getAt(pos);
			if (service.already_monitored) {
				aux.set("already_monitored", true);
			}
			if (service.selected) {
				aux.set("selected", true);
			}
		}
	}
}

function addHostsToHostgroupOnServer(hostsIds, hostgroupId) {

	if (hostsIds.length === 0) {
		return;	
	}

	Ext.getCmp('hostGroupsTreePanel').disable();

	var params = {
		hostgroup_id: hostgroupId,
		hosts: JSON.stringify(hostsIds)
	};

	Ext.Ajax.request({

		url: '/opmon/seagull/www/index.php/discovery/action/hostgroups/operation/addhoststohostgroup/',
		method: 'POST',
		params: params,
		success: function(result, request) {

			var obj;

			obj = JSON.parse(result.responseText);
			if (!obj) {
				showError("Unexpected error", "Unable parse", result.responseText);
				return;
			}

			if (!obj.success) {
				showError("Unexpected error", obj.message, obj);
				return;			
			}

			Ext.getCmp('hostGroupsTreePanel').enable();

		},
		failure: function(result, request) {
			showError("Unexpected error","Unable to reach server");
		}

	});
}



function addContactsToContactgroupOnServer(contactsIds, contactgroupId) {

	if (contactsIds.length == 0) {
		return;	
	}

	Ext.getCmp('teamsTreePanel').disable();

	var params = {
		contactgroup_id: contactgroupId,
		contacts: JSON.stringify(contactsIds)
	};

	Ext.Ajax.request({

		url: '/opmon/seagull/www/index.php/discovery/action/contactgroups/operation/addcontactstocontactgroup/',
		method: 'POST',
		params: params,
		success: function(result, request) {

			var obj;

			obj = JSON.parse(result.responseText);
			if (!obj) {
				showError(
					"Unexpected error",
					"Unable parse",
					result.responseText
				);
				return;
			}

			if (!obj.success) {
				showError(
					"Unexpected error",
					obj.message,
					obj
				);
				return;			
			}

			Ext.getCmp('teamsTreePanel').enable();

		},
		failure: function(result, request) {
			showError(
				"Unexpected error",
				"Unable to reach server"
			);
		}

	});
}

function indexOfObject(arr, prop, val) {

	var i;
	var aux;

	for(i=0; i<arr.length; i++) {
		aux = arr[i];
		if (aux[prop] == val) {
			return i;	
		}
	}

	return -1;
}

function makeActiveView(itemId) {

	var it;
	var fullPath = "Wizard.view."+itemId;

	if (viewPortItems.indexOf(itemId) < 0) {
		viewPortItems.push(itemId);
		it = Ext.create(fullPath);
		Ext.getCmp('WizardMainViewPort').add(it);
	}

	if (Wizard.currentCard !== null) {
		Wizard.lastCard = Wizard.currentCard;
	}
	Wizard.currentCard = itemId;

	Ext.getCmp('WizardMainViewPort').getLayout().setActiveItem(itemId);

}

function filterServices() {
	var services;
	var regexStr;
	var textfield;

	textfield = Ext.getCmp("filterField");

	regexStr = ".*"+textfield.getValue()+".*";

	services = Wizard.getApplication().getServiceStoreStore();
	services.clearFilter(true);
	services.filter("service_description",new RegExp(regexStr,"i"));	
}

/*
 * Change some invalid chars from str
 * received as parameter and return the
 * changed string
 */
function changeCharCode(str) {

	var repName = "";
	for(i=0; i<str.length; i++) {
		var character = str.charAt(i);
		var code = str.charCodeAt(i);

		if(code >= 224 && code <= 230) {
			repName += "a";
		}
		else if(code >= 232 && code <= 235) {
			repName += "e";
		}
		else if(code >= 236 && code <= 239) {
			repName += "i";
		}
		else if(code >= 240 && code <= 246) {
			repName += "o";
		}
		else if(code >= 249 && code <= 253) {
			repName += "u";
		}
		else if(code == 231) {
			repName += "c";
		}
		else if(code == 199) {
			repName += "C";
		}
		else if(code >= 192 && code <= 198 ) {
			repName += "A";
		}
		else if(code >= 200 && code <= 203 ) {
			repName += "E";
		}
		else if(code >= 204 && code <= 207 ) {
			repName += "I";
		}
		else if(code >= 210 && code <= 214 ) {
			repName += "O";
		}
		else if(code >= 217 && code <= 220 ) {
			repName += "U";
		}
		else if(character == " ") {
			repName += "_";
		}else if(  (code >= 97 && code <= 122)  ||
				 (code >= 65 && code <= 90)   ||
				 (code >= 48 && code <= 57)   ||
				 (character == "\n") || 
				 (character == "_" ) ||
				 (character == "." ) ||
				 (character == "-" ) ||
				 (character == "/" ) ) {

			repName += character;
		}

	}

	return repName;
}

function isLicensed (elementToVerify, selectedItems, translatedtext) {
	var licenseStore = Ext.getStore("licenseStore");
	var lic = licenseStore.getAt(0);
	console.log(lic);

	if (lic.get('licensed')) {				

		var licenseLimit = lic.get(elementToVerify + 's_limit');
		var licenseMonitored = lic.get(elementToVerify + 's_monitored');		
		var totalHost = licenseMonitored + selectedItems;

		if (lic.get(licenseLimit) == "Unlimited") {			
			return true;
		}

		if (licenseMonitored + selectedItems > licenseLimit){

			translatedtext.msg = t("licenseExceededMsg"+ elementToVerify)
			.replace("%LICENSEMONITORED%", licenseMonitored )
			.replace("%LICENSELIMIT%",licenseLimit)
			.replace("%SELECTED%", selectedItems);

			return false;
		}
	}
	return true;
}


function Opmon_validateStore(context, store, callback) {
	var result = {keys: [], indexs: []};
	var hasErr = false;
	
	function extractFromStore(item) {
		return context.requires.reduce(function(prev, curr) {
			prev[curr] = item.data[curr];
			return prev;
		}, {});
	}

	function verifyHasOwnValidator() {
		return context.validator && typeof context.validator === 'function';
	}

	function executeCb(params) {
		if(verifyHasOwnValidator()) {
			return context.validator.apply(context, params || []);
		}
	}

	function verifyError(curr, arrIndex) {
		var req = context.requires;
		for(var i in req) {
			if(executeCb([curr, req[i]]) === false || curr[req[i]] === "") {
				result.indexs.push(arrIndex);
				result.keys.push(req[i]);
				result.obj = curr;
				hasErr = true;
			}
		}
	}
	
	store.data.items.map(extractFromStore).forEach(verifyError);
	
	callback(hasErr, result);
}
