/*
 * File: app/view/modal/new_host.js
 *
 * This file was generated by Sencha Architect version 3.5.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.view.modal.new_host', {
    extend: 'Ext.window.Window',
    alias: 'widget.modalnew_host',

    requires: [
        'Ext.form.Panel',
        'Ext.form.field.TextArea',
        'Ext.form.field.Hidden',
        'Ext.toolbar.Toolbar',
        'Ext.toolbar.Spacer',
        'Ext.button.Button'
    ],

    height: 260,
    id: 'modal_new_host',
    width: 420,
    overflowY: 'auto',
    layout: 'card',
    bodyPadding: 0,
    title: '{{Add new host manually}}',
    modal: true,

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'form',
                    height: 120,
                    id: 'new_host_form',
                    width: 400,
                    bodyPadding: 13,
                    items: [
                        {
                            xtype: 'textfield',
                            anchor: '100%',
                            fieldLabel: 'IP',
                            inputId: 'ip',
                            allowBlank: false,
                            listeners: {
                                boxready: {
                                    fn: me.onTextfieldBoxReady,
                                    scope: me
                                }
                            }
                        },
                        {
                            xtype: 'textfield',
                            anchor: '100%',
                            fieldLabel: '{{Hostname}}',
                            inputId: 'hostname',
                            allowBlank: false
                        },
                        {
                            xtype: 'textareafield',
                            anchor: '100%',
                            height: 105,
                            fieldLabel: '{{Description}}',
                            inputId: 'description',
                            allowBlank: false
                        },
                        {
                            xtype: 'hiddenfield',
                            anchor: '100%',
                            fieldLabel: 'Label',
                            value: 2,
                            inputId: 'state'
                        }
                    ],
                    dockedItems: [
                        {
                            xtype: 'toolbar',
                            dock: 'bottom',
                            items: [
                                {
                                    xtype: 'tbspacer',
                                    flex: 1
                                },
                                {
                                    xtype: 'button',
                                    handler: function(button, e) {
                                        Ext.getCmp('modal_new_host').layout.setActiveItem('add_multiple_host_form');
                                    },
                                    tabIndex: 1,
                                    text: '{{Add more than one}}'
                                },
                                {
                                    xtype: 'container',
                                    items: [
                                        {
                                            xtype: 'button',
                                            handler: function(button, e) {
                                                var form = Ext.getCmp('new_host_form');

                                                if (form.isValid()) {
                                                    Ext.getStore('hosts').add(form.getValues());

                                                    Ext.getCmp('modal_new_host').destroy();

                                                    var position = Ext.getCmp('host_list').store.data.items.length - 1;
                                                    position = Ext.getCmp('host_list').store.data.items[position];

                                                    Ext.getCmp('host_list').selModel.doSelect(position, true);
                                                    Ext.getCmp('host_list').updateLayout();
                                                }
                                            },
                                            iconCls: 'fa fa-check icon-white',
                                            text: '{{Create new host}}'
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                },
                {
                    xtype: 'form',
                    id: 'add_multiple_host_form',
                    bodyPadding: 13,
                    header: false,
                    title: 'My Form',
                    layout: {
                        type: 'vbox',
                        align: 'stretch'
                    },
                    items: [
                        {
                            xtype: 'textareafield',
                            flex: 1,
                            maxHeight: 130,
                            fieldLabel: '{{Add multiple hosts. Write as follow: ip,hostname,description. Write one host per line.}}',
                            labelAlign: 'top',
                            name: 'multiple_hosts',
                            inputId: 'multiple_hosts',
                            allowBlank: false,
                            emptyText: '{{192.168.10.1,linux server 07,intranet and website server.}}'
                        }
                    ],
                    dockedItems: [
                        {
                            xtype: 'toolbar',
                            dock: 'bottom',
                            items: [
                                {
                                    xtype: 'tbspacer',
                                    flex: 1
                                },
                                {
                                    xtype: 'button',
                                    handler: function(button, e) {
                                        Ext.getCmp('modal_new_host').layout.setActiveItem('new_host_form');
                                    },
                                    tabIndex: 1,
                                    text: '{{Add just one}}'
                                },
                                {
                                    xtype: 'container',
                                    items: [
                                        {
                                            xtype: 'button',
                                            handler: function(button, e) {
                                                var form = Ext.getCmp('add_multiple_host_form');
                                                if (form.isValid()) {

                                                    var form_values = form.getValues();
                                                    form_values = form_values.multiple_hosts;
                                                    form_array = form_values.split(/\r\n|\r|\n/g);
                                                    //console.log(form_array);
                                                    for(var i = 0; i < form_array.length; i++) {
                                                        var received_values = form_array[i].split(',');
                                                        var new_host = { ip: received_values[0], hostname: received_values[1], description: received_values[2] };
                                                        // 		console.log(new_host);
                                                        Ext.getStore('hosts').add(new_host);
                                                        var position = Ext.getCmp('host_list').store.data.items.length - 1;
                                                        position = Ext.getCmp('host_list').store.data.items[position];
                                                        Ext.getCmp('host_list').selModel.doSelect(position, true);
                                                    }

                                                    Ext.getCmp('modal_new_host').destroy();
                                                }
                                            },
                                            iconCls: 'fa fa-check icon-white',
                                            text: '{{Create new hosts}}'
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    onTextfieldBoxReady: function(component, width, height, eOpts) {
        component.focus();
    }

});