/*
 * File: app/view/modal/new_snmp.js
 *
 * This file was generated by Sencha Architect version 3.5.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.view.modal.new_snmp', {
    extend: 'Ext.window.Window',
    alias: 'widget.modalnew_snmp',

    requires: [
        'Ext.form.Panel',
        'Ext.form.FieldSet',
        'Ext.form.field.ComboBox',
        'Ext.toolbar.Toolbar',
        'Ext.button.Button',
        'Ext.panel.Tool'
    ],

    height: 301,
    id: 'modalnew_snmp',
    width: 350,
    overflowY: 'auto',
    layout: 'fit',
    closable: false,
    title: '{{Create new SNMP Community}}',
    modal: true,

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'form',
                    id: 'snmp_form',
                    overflowY: 'auto',
                    bodyPadding: 10,
                    header: false,
                    title: 'My Form',
                    items: [
                        {
                            xtype: 'textfield',
                            anchor: '100%',
                            id: 'snmp_name',
                            fieldLabel: '{{Authentication name}}',
                            labelAlign: 'top',
                            name: 'snmp_name',
                            allowBlank: false
                        },
                        {
                            xtype: 'fieldset',
                            id: 'snmp_auth',
                            margin: '9 0 5',
                            title: '{{Authentication}}',
                            items: [
                                {
                                    xtype: 'textfield',
                                    anchor: '100%',
                                    id: 'snmp_auth_community',
                                    fieldLabel: '{{Community}}',
                                    name: 'snmp_auth_community'
                                },
                                {
                                    xtype: 'combobox',
                                    anchor: '100%',
                                    hidden: true,
                                    id: 'snmp_auth_protocol',
                                    fieldLabel: '{{Protocol}}',
                                    name: 'snmp_auth_protocol',
                                    displayField: 'name',
                                    queryMode: 'local',
                                    store: 'snmp_authprotocol_store'
                                },
                                {
                                    xtype: 'textfield',
                                    anchor: '100%',
                                    hidden: true,
                                    id: 'snmp_auth_password',
                                    fieldLabel: '{{Password}}',
                                    name: 'snmp_auth_password'
                                }
                            ]
                        },
                        {
                            xtype: 'fieldset',
                            hidden: true,
                            id: 'snmp_sec',
                            margin: '9 0 5',
                            title: '{{Security}}',
                            items: [
                                {
                                    xtype: 'combobox',
                                    anchor: '100%',
                                    id: 'snmp_sec_level',
                                    fieldLabel: '{{Level}}',
                                    name: 'snmp_sec_level',
                                    displayField: 'name',
                                    queryMode: 'local',
                                    store: 'snmp_seclevel_store'
                                },
                                {
                                    xtype: 'textfield',
                                    anchor: '100%',
                                    id: 'snmp_sec_context',
                                    fieldLabel: '{{Context}}',
                                    name: 'snmp_sec_context'
                                },
                                {
                                    xtype: 'textfield',
                                    anchor: '100%',
                                    id: 'snmp_sec_user',
                                    fieldLabel: '{{User}}',
                                    name: 'snmp_sec_user'
                                }
                            ]
                        },
                        {
                            xtype: 'fieldset',
                            hidden: true,
                            id: 'snmp_priv',
                            margin: '9 0 5',
                            title: '{{Privacy}}',
                            items: [
                                {
                                    xtype: 'combobox',
                                    anchor: '100%',
                                    id: 'snmp_priv_protocol',
                                    fieldLabel: '{{Protocol}}',
                                    name: 'snmp_priv_protocol',
                                    displayField: 'name',
                                    queryMode: 'local',
                                    store: 'snmp_privprotocol_store'
                                },
                                {
                                    xtype: 'textfield',
                                    anchor: '100%',
                                    id: 'snmp_priv_password',
                                    fieldLabel: '{{Password}}',
                                    name: 'snmp_priv_password'
                                },
                                {
                                    xtype: 'textfield',
                                    anchor: '100%',
                                    id: 'snmp_priv_target',
                                    fieldLabel: '{{Target}}',
                                    name: 'snmp_priv_target'
                                }
                            ]
                        },
                        {
                            xtype: 'textfield',
                            anchor: '100%',
                            id: 'snmp_extra',
                            fieldLabel: '{{Extra parameter}}',
                            labelAlign: 'top',
                            name: 'snmp_extra'
                        }
                    ],
                    dockedItems: [
                        {
                            xtype: 'toolbar',
                            dock: 'bottom',
                            layout: {
                                type: 'hbox',
                                pack: 'end'
                            },
                            items: [
                                {
                                    xtype: 'container',
                                    items: [
                                        {
                                            xtype: 'button',
                                            handler: function(button, e) {
                                                var snmp_form = Ext.getCmp('snmp_form').getForm();
                                                var snmp_store = Ext.getStore('snmppassauth_store');
                                                snmp_store.add(snmp_form.getValues());

                                                var snmp_name = snmp_form.findField('snmp_name').getValue();
                                                var parent_combo = model_wiz.id_cache;
                                                Ext.getCmp(parent_combo.id).setValue(snmp_name);

                                                Ext.getCmp('modalnew_snmp').destroy();
                                            },
                                            text: '{{Save}}'
                                        }
                                    ]
                                }
                            ]
                        },
                        {
                            xtype: 'toolbar',
                            dock: 'top',
                            ui: 'footer',
                            items: [
                                {
                                    xtype: 'combobox',
                                    flex: 1,
                                    margin: '0 9 0 5',
                                    fieldLabel: '{{SNMP Version}}',
                                    labelWidth: 120,
                                    name: 'snmp_version',
                                    value: 'v1',
                                    displayField: 'name',
                                    queryMode: 'local',
                                    store: 'snmp_version_store',
                                    valueField: 'value',
                                    listeners: {
                                        change: {
                                            fn: me.onComboboxChange,
                                            scope: me
                                        }
                                    }
                                }
                            ]
                        }
                    ]
                }
            ],
            tools: [
                {
                    xtype: 'tool',
                    type: 'close',
                    listeners: {
                        click: {
                            fn: me.onToolClick,
                            scope: me
                        }
                    }
                }
            ]
        });

        me.callParent(arguments);
    },

    onComboboxChange: function(field, newValue, oldValue, eOpts) {
        if (newValue === 'v1' || newValue === 'v2c') {
        	Ext.get('snmp_auth_protocol').hide();
        	Ext.get('snmp_auth_password').hide();
        	Ext.get('snmp_priv').hide();
        	Ext.get('snmp_sec').hide();
            Ext.get('snmp_auth_community').show();
        } else {
        	Ext.get('snmp_auth_community').hide();
        	Ext.get('snmp_auth_protocol').show();
        	Ext.get('snmp_auth_password').show();
        	Ext.get('snmp_priv').show();
        	Ext.get('snmp_sec').show();
        }

        Ext.getCmp('snmp_form').doLayout();
    },

    onToolClick: function(tool, e, eOpts) {
        var parent_combo = model_wiz.id_cache;
        Ext.getCmp(parent_combo.id).setValue('');
        Ext.getCmp('modalnew_snmp').destroy();
    }

});