/*
 * File: app/view/model/box.js
 *
 * This file was generated by Sencha Architect version 3.5.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.view.model.box', {
    extend: 'Ext.container.Container',
    alias: 'widget.modelbox',

    requires: [
        'Ext.form.Panel',
        'Ext.form.field.Display',
        'Ext.form.field.Hidden',
        'Ext.toolbar.Toolbar',
        'Ext.button.Button',
        'Ext.toolbar.Spacer'
    ],

    cls: 'model-square',
    height: 190,
    itemId: 'model_box',
    margin: '0 10 10 0',
    maxWidth: 250,
    minWidth: 250,
    width: 250,

    layout: {
        type: 'vbox',
        align: 'stretch'
    },

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'form',
                    flex: 1,
                    bodyCls: 'grey-light-bg',
                    bodyPadding: 0,
                    header: false,
                    title: 'My Form',
                    items: [
                        {
                            xtype: 'displayfield',
                            anchor: '100%',
                            itemId: 'name',
                            margin: 0,
                            fieldLabel: '',
                            name: 'name',
                            value: 'Display Field',
                            fieldCls: 'x-form-display-field model-name'
                        },
                        {
                            xtype: 'container',
                            itemId: 'model_innerwrapper',
                            layout: {
                                type: 'hbox',
                                align: 'stretch'
                            },
                            items: [
                                {
                                    xtype: 'displayfield',
                                    itemId: 'services_length',
                                    margin: 0,
                                    fieldLabel: '',
                                    name: 'services_quantity',
                                    value: 'Display Field',
                                    fieldCls: 'x-form-display-field model-services-num'
                                },
                                {
                                    xtype: 'displayfield',
                                    flex: 1,
                                    itemId: 'services_length_label',
                                    margin: '0 0 0 3',
                                    fieldLabel: '',
                                    value: '{{Services}}',
                                    fieldCls: 'x-form-display-field model-services-num'
                                },
                                {
                                    xtype: 'container',
                                    flex: 1
                                },
                                {
                                    xtype: 'displayfield',
                                    itemId: 'version_label',
                                    margin: '0 3 0 0',
                                    fieldLabel: '',
                                    value: '{{Version}}',
                                    fieldCls: 'x-form-display-field model-version'
                                },
                                {
                                    xtype: 'displayfield',
                                    itemId: 'version',
                                    margin: 0,
                                    fieldLabel: '',
                                    name: 'version',
                                    value: 'Display Field',
                                    fieldCls: 'x-form-display-field model-version'
                                }
                            ]
                        },
                        {
                            xtype: 'displayfield',
                            anchor: '100%',
                            itemId: 'description',
                            margin: 0,
                            fieldLabel: '',
                            name: 'description',
                            value: 'Display Field',
                            fieldCls: 'x-form-display-field model-description'
                        },
                        {
                            xtype: 'hiddenfield',
                            anchor: '100%',
                            fieldLabel: 'Label',
                            name: 'id'
                        }
                    ]
                },
                {
                    xtype: 'container',
                    itemId: 'model_toolbar',
                    layout: {
                        type: 'hbox',
                        align: 'stretch'
                    },
                    items: [
                        {
                            xtype: 'toolbar',
                            cls: 'grey-light-bg',
                            maxWidth: 103,
                            minWidth: 103,
                            padding: 0,
                            width: 103,
                            items: [
                                {
                                    xtype: 'button',
                                    height: 24,
                                    itemId: 'model_details_btn',
                                    margin: 0,
                                    enableToggle: true,
                                    iconCls: 'fa  fa-plus-square-o icon-half-black',
                                    text: '{{Details}}'
                                },
                                {
                                    xtype: 'tbspacer'
                                }
                            ]
                        },
                        {
                            xtype: 'button',
                            handler: function(button, e) {
                                Ext.getCmp("card_container").layout.setActiveItem("step_02");
                                Ext.getCmp("card_header").layout.setActiveItem("step_02_header");
                                Ext.getCmp("back_btn").show();
                                Ext.getCmp("next_btn").show();
                                if (Ext.getStore("selected_hosts_store").getCount() > 0) {
                                    Ext.getCmp("next_btn").setDisabled(false);
                                } else {
                                    Ext.getCmp("next_btn").setDisabled(true);
                                }

                                Ext.getCmp("per_categories_content_top").hide();
                                Ext.getCmp("full_list_content_top").hide();


                                var parent_container = button.up('modelbox');
                                var form = parent_container.child('form');
                                var form_id = form.getForm().findField('id').getSubmitValue();
                                console.log(form_id);

                                var models = Ext.getStore('models_store');
                                var model_record = models.findRecord('id', form_id);
                                console.log(model_record);

                                var selected_model = Ext.getStore('selected_models_store');
                                selected_model.removeAll();
                                selected_model.add(model_record);
                                console.log(selected_model);
                            },
                            height: 24,
                            itemId: 'model_use_btn',
                            style: '{ left: 127 !important; }',
                            text: '{{Use this model}}'
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    }

});