/*
 * File: app/view/model/panel.js
 *
 * This file was generated by Sencha Architect version 3.5.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.view.model.panel', {
    extend: 'Ext.panel.Panel',
    alias: 'widget.modelpanel',

    requires: [
        'model_wiz.view.model.step',
        'Ext.tab.Panel',
        'Ext.tab.Bar',
        'Ext.form.Panel',
        'Ext.tab.Tab',
        'Ext.toolbar.Toolbar'
    ],

    hosts: '[]',
    beingedited: '',
    layout: 'hbox',
    hideCollapseTool: true,
    title: '{{Model Name}}',

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'container',
                    flex: 1,
                    padding: '8 0 0 0',
                    layout: {
                        type: 'vbox',
                        align: 'stretch'
                    },
                    items: [
                        {
                            xtype: 'tabpanel',
                            height: 36,
                            hidden: true,
                            id: 'selected_hosts_tab',
                            margin: '0 6',
                            maxHeight: 36,
                            activeTab: 0,
                            plain: true,
                            tabBar: {
                                xtype: 'tabbar',
                                cls: 'aoptabs-fakemenu'
                            },
                            listeners: {
                                beforeshow: {
                                    fn: me.onTabpanelBeforeShow1,
                                    scope: me
                                },
                                hide: {
                                    fn: me.onTabpanelHide1,
                                    scope: me
                                }
                            }
                        },
                        {
                            xtype: 'tabpanel',
                            flex: 1,
                            cls: 'opsubpanel',
                            margin: '0 0 0 6',
                            header: false,
                            headerPosition: 'right',
                            title: 'model steps',
                            titleAlign: 'right',
                            titleCollapse: false,
                            activeTab: 0,
                            plain: true,
                            tabBar: {
                                xtype: 'tabbar',
                                cls: 'optabs-fakemenu',
                                margin: '0 10 0 0',
                                plain: true,
                                listeners: {
                                    change: {
                                        fn: me.onTabbarChange,
                                        scope: me
                                    }
                                }
                            },
                            items: [
                                {
                                    xtype: 'modelstep',
                                    title: 'Key parameters'
                                },
                                {
                                    xtype: 'modelstep',
                                    title: 'Memmory'
                                },
                                {
                                    xtype: 'modelstep',
                                    title: 'CPU'
                                }
                            ],
                            listeners: {
                                boxready: {
                                    fn: me.onStep_03_contentBoxReady,
                                    scope: me
                                }
                            }
                        }
                    ]
                },
                {
                    xtype: 'toolbar',
                    padding: '6 0 6 6 ',
                    items: [
                        {
                            xtype: 'button',
                            text: 'Configure one by one',
                            listeners: {
                                click: {
                                    fn: me.onButtonClick,
                                    scope: me
                                }
                            }
                        },
                        {
                            xtype: 'button',
                            text: 'Configure all',
                            listeners: {
                                click: {
                                    fn: me.onButtonClick1,
                                    scope: me
                                }
                            }
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    onTabpanelBeforeShow1: function(component, eOpts) {
        var selected_hosts = Ext.getStore('selected_hosts_store');
        console.log(Ext.getStore("selected_hosts_store"));
        console.log('aaa');
        var hosts = selected_hosts.data.items;
        for (var i = 0; i < hosts.length; i++) {
            var new_panel = Ext.create('Ext.panel.Panel', {
                title: hosts[i].data.hostname,
                width: 200,
            });
            component.add(new_panel);
        }
        component.setActiveTab(0);
        console.log(component);
    },

    onTabpanelHide1: function(component, eOpts) {
        component.removeAll();
    },

    onTabbarChange: function(tabBar, tab, card, eOpts) {
        tab.addCls("tab-done");
    },

    onStep_03_contentBoxReady: function(component, width, height, eOpts) {
        Ext.getCmp(component.tabBar.activeTab.id).addCls("tab-done");
        var tabs = component.tabBar.items.items;
        for (var i = 0; i < tabs.length; i++) {
        	var el  = tabs[i].id;
        	Ext.getCmp(el).addCls("tab-for-all");
        }
    },

    onButtonClick: function(button, e, eOpts) {
        Ext.getCmp("selected_hosts_tab").show();
    },

    onButtonClick1: function(button, e, eOpts) {
        Ext.getCmp("selected_hosts_tab").hide();
    },

    forward: function(child,event) {
        if (event === 'record') {
        	console.log('recording ' + child.id + ' data...');
        } else {
        	console.log('requiring data for ' + child.id + '...');
        }

    }

});