/*
 * File: app/view/step_02.js
 *
 * This file was generated by Sencha Architect version 3.5.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('model_wiz.view.step_02', {
    extend: 'Ext.container.Container',
    alias: 'widget.step_02',

    requires: [
        'Ext.grid.Panel',
        'Ext.grid.column.Template',
        'Ext.XTemplate',
        'Ext.form.field.Text',
        'Ext.view.Table',
        'Ext.toolbar.Toolbar',
        'Ext.button.Button',
        'Ext.selection.CheckboxModel'
    ],

    id: 'step_02',

    layout: {
        type: 'hbox',
        align: 'stretch'
    },

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'gridpanel',
                    flex: 1,
                    id: 'host_list',
                    width: 1074,
                    header: false,
                    title: 'My Grid Panel',
                    columnLines: false,
                    emptyText: '{{Any host finded. Add a new manually}}',
                    forceFit: false,
                    store: 'hosts',
                    columns: [
                        {
                            xtype: 'templatecolumn',
                            tpl: [
                                '<tpl for=".">',
                                '	<tpl if="status === 1"><div class="x-btn-default-small mark_monitored_host" title="{{Monitored host}}"></div></tpl>',
                                '	<tpl if="status === 2"><div class="mark_manual_host" title="{{Host added manually}}"></div></tpl>',
                                '	<tpl if="status === 0"><div class="mark_discovered_host"></div></tpl>',
                                '</tpl>'
                            ],
                            width: 8,
                            sortable: false,
                            dataIndex: 'status',
                            menuDisabled: true,
                            text: ''
                        },
                        {
                            xtype: 'gridcolumn',
                            width: 120,
                            dataIndex: 'ip',
                            text: 'IP',
                            editor: {
                                xtype: 'textfield'
                            }
                        },
                        {
                            xtype: 'gridcolumn',
                            width: 300,
                            dataIndex: 'hostname',
                            text: '{{Hostname}}'
                        },
                        {
                            xtype: 'gridcolumn',
                            dataIndex: 'description',
                            text: '{{Description}}',
                            flex: 1
                        }
                    ],
                    viewConfig: {
                        xtype: 'tableview',
                        enableTextSelection: true
                    },
                    dockedItems: [
                        {
                            xtype: 'toolbar',
                            dock: 'top',
                            layout: {
                                type: 'hbox',
                                pack: 'end'
                            },
                            items: [
                                {
                                    xtype: 'textfield',
                                    id: 'search_ip',
                                    margin: '0 8 0 28',
                                    width: 111,
                                    fieldLabel: '',
                                    listeners: {
                                        change: {
                                            fn: me.onSearch_ipChange,
                                            scope: me
                                        }
                                    }
                                },
                                {
                                    xtype: 'textfield',
                                    id: 'search_hostname',
                                    width: 292,
                                    fieldLabel: ''
                                },
                                {
                                    xtype: 'textfield',
                                    flex: 3,
                                    id: 'search_description',
                                    fieldLabel: ''
                                }
                            ]
                        },
                        {
                            xtype: 'toolbar',
                            dock: 'bottom',
                            layout: {
                                type: 'hbox',
                                pack: 'center'
                            },
                            items: [
                                {
                                    xtype: 'button',
                                    handler: function(button, e) {
                                        Ext.create(model_wiz.view.modal.new_host, {
                                            renderTo: Ext.getBody()
                                        }).show();
                                    },
                                    iconCls: 'fa fa-plus icon-green',
                                    text: '{{Add new host manually}}'
                                }
                            ]
                        }
                    ],
                    selModel: Ext.create('Ext.selection.CheckboxModel', {
                        checkOnly: true,
                        injectCheckbox: 1,
                        showHeaderCheckbox: true
                    }),
                    listeners: {
                        selectionchange: {
                            fn: me.onHost_listSelectionChange,
                            scope: me
                        }
                    }
                }
            ]
        });

        me.callParent(arguments);
    },

    onSearch_ipChange: function(field, newValue, oldValue, eOpts) {
        console.log(field.triggers.search_ip_search_clear.id);
        console.log(field.triggers.search_ip_search_mag.id);
        if (newValue === "") {
        	console.log(newValue);
        	Ext.getCmp('search_ip_search_mag').show();
        	Ext.getCmp('search_ip_search_clear').hide();
        } else {
        	Ext.getCmp('search_ip_search_mag').hide();
        	Ext.getCmp('search_ip_search_clear').show();
        	console.log("faaaa");
        }
    },

    onHost_listSelectionChange: function(model, selected, eOpts) {
        var selected_hosts = Ext.getStore('selected_hosts_store');

        if (selected.length > 0) {
            Ext.getCmp("next_btn").setDisabled(false);
            selected_hosts.removeAll();
            selected_hosts.add(selected);
        } else {
            Ext.getCmp("next_btn").setDisabled(true);
            selected_hosts.removeAll();
        }
        Ext.getCmp("host_selected_count").setValue(selected.length + " {{host(s) selected}}");
        Ext.getCmp("host_selected_count_1").setValue(selected.length + " {{host(s) selected}}");
    }

});